package com.jusfoun.ydylsz.controller;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.jusfoun.ydylsz.service.CameraAreaService;
import com.jusfoun.ydylsz.service.KshHlhtSbxxService;
import com.jusfoun.ydylsz.vo.out.base.RootResult;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

/**
 * @Classname CameraAreaController
 * @Description 摄像头区域
 * @Date 2023/12/14 15:48
 * @Created by rising123sun
 */
@Api(description = "摄像头区域")
@RestController
@RequestMapping("/cameraArea")
@CrossOrigin
public class CameraAreaController {

    @Autowired
    private CameraAreaService cameraAreaService;

    // 新增摄像头区域
//    @PostMapping("/addCameraArea")
//    public RootResult<Object> addCameraArea(@RequestParam(value = "cookie") String cookie) {
//        RootResult<Object> r = new RootResult<>();
//        try {
//            JSONArray result = cameraAreaService.addCameraArea(cookie);
//            r.setData(result);
//            r.setCode(200);
//            System.out.println(r);
//        } catch (Exception e) {
//            r.setMsg(e.getMessage());
//            e.printStackTrace();
//            r.setCode(500);
//        }
//        return r;
//    }

    // 获取所有摄像头区域
    @PostMapping("/getCameraAreas")
    public RootResult<Object> getCameraAreas(@RequestParam(value = "orgCode",required = false) String orgCode) {
        RootResult<Object> r = new RootResult<>();
        try {
            JSONObject result = cameraAreaService.getCameraAreas(orgCode);
            r.setData(result);
            r.setCode(200);
        } catch (Exception e) {
            r.setMsg(e.getMessage());
            e.printStackTrace();
            r.setCode(500);
        }
        return r;
    }

}
