package	com.jusfoun.ydylsz.controller;

import com.github.pagehelper.PageInfo;
import com.jusfoun.ydylsz.service.DXPPointService;
import com.jusfoun.ydylsz.vo.DXPCFXXVO;
import com.jusfoun.ydylsz.vo.KqImageVO;
import com.jusfoun.ydylsz.vo.PointVO;
import com.jusfoun.ydylsz.vo.TreeNode;
import com.jusfoun.ydylsz.vo.out.base.RootResult;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;


/**
  *  展示信息
 * @author lidaoquan
 */
@RestController
@RequestMapping("/point")
@Api(description="描点信息数据接口")
public class DXPTotalController{

	@Autowired
	private DXPPointService dxpPointService;

	//详情
	@ApiOperation(value = "描点图-新增", notes = "参数：point")	
	@RequestMapping(value = "/savePoint", method = RequestMethod.POST)
	@ResponseBody
	public RootResult<Object> savePoint(@ModelAttribute PointVO point){
		RootResult<Object> r = new RootResult<Object>();
		try {
			dxpPointService.savePoint(point);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return r;
	}

	@ApiOperation(value = "描点图-删除所有点位", notes = "参数：kqbh")
	@RequestMapping(value = "/deletePoint", method = RequestMethod.POST)
	@ResponseBody
	public RootResult<Object> deletePoint(String kqbh){
		RootResult<Object> r = new RootResult<Object>();
		try {
			dxpPointService.deletePoint(kqbh);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return r;
	}

	@ApiOperation(value = "描点图-详情", notes = "参数：kqbh")
	@RequestMapping(value = "/pointDetail", method = RequestMethod.POST)
	@ResponseBody
	public RootResult<List<PointVO>> pointDetail(String kqbh,String type){
		RootResult<List<PointVO>> r = new RootResult<List<PointVO>>();
		try {
			List<PointVO> list = dxpPointService.pointDetail(kqbh,type);
			for(PointVO pointVO:list){
				if("0".equals(pointVO.getType())){
					DXPCFXXVO dxpcfxxvo = dxpPointService.selectDetail(pointVO.getIndex());
					pointVO.setDxpcfxxvo(dxpcfxxvo);
				}
			}
			r.setData(list);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return r;
	}

	//详情
	@ApiOperation(value = "库区和库区图-新增", notes = "参数：point")
	@RequestMapping(value = "/saveImage", method = RequestMethod.POST)
	@ResponseBody
	public RootResult<Object> saveImage(@ModelAttribute KqImageVO kqImageVO){
		RootResult<Object> r = new RootResult<Object>();
		try {
			dxpPointService.saveImage(kqImageVO);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return r;
	}
	
	@ApiOperation(value = "库区和库区图-详情", notes = "参数：kqbh")
	@RequestMapping(value = "/imageDetail", method = RequestMethod.POST)
	@ResponseBody
	public RootResult<KqImageVO> imageDetail(String kqbh){
		RootResult<KqImageVO> r = new RootResult<KqImageVO>();
		try {
			r.setData(dxpPointService.imageDetail(kqbh));
		} catch (Exception e) {
			e.printStackTrace();
		}
		return r;
	}

	@ApiOperation(value = "描点图-仓房和视频头接口", notes = "参数：kqbh，type")
	@RequestMapping(value = "/indexData", method = RequestMethod.POST)
	@ResponseBody
	public RootResult<List<TreeNode>> indexData(String type,String kqbh){
		RootResult<List<TreeNode>> r = new RootResult<List<TreeNode>>();
		try {
			r.setData(dxpPointService.indexData(kqbh,type));
		} catch (Exception e) {
			e.printStackTrace();
		}
		return r;
	}
	
}