package com.jusfoun.ydylsz.controller;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.URLEncoder;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.stream.Collectors;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.jusfoun.ydylsz.vo.CameraMalfunctionDO;
import com.jusfoun.ydylsz.vo.CameraMalfunctionDTO;
import com.jusfoun.ydylsz.vo.CameraMalfunctionVO;
import com.jusfoun.ydylsz.vo.CameraStatistics;
import com.jusfoun.ydylsz.vo.in.CameraStatisticsVO;
import org.apache.commons.lang.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.hikvision.artemis.sdk.ArtemisHttpUtil;
import com.hikvision.artemis.sdk.config.ArtemisConfig;
import com.jusfoun.ydylsz.haikang.ControllingRequest;
import com.jusfoun.ydylsz.pojo.KshHlhtSbxx;
import com.jusfoun.ydylsz.pojo.KshHlhtXzqh;
import com.jusfoun.ydylsz.pojo.KshHlhtZzsbgl;
import com.jusfoun.ydylsz.service.KshHlhtSbxxService;
import com.jusfoun.ydylsz.service.KshHlhtZzjgService;
import com.jusfoun.ydylsz.util.ExcelModelUtils;
import com.jusfoun.ydylsz.util.PageUtils;
import com.jusfoun.ydylsz.utils.BeanUtil;
import com.jusfoun.ydylsz.vo.in.KshHlhtSbxxInVo;
import com.jusfoun.ydylsz.vo.in.KshHlhtSbxxInputVo;
import com.jusfoun.ydylsz.vo.out.base.RootResult;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import net.sf.jxls.transformer.XLSTransformer;


@Api(description = "设备信息接口")
@Controller
@RequestMapping(value = "/kshHlhtSbxx")
@CrossOrigin
public class KshHlhtSbxxController {

    @Autowired
    private KshHlhtSbxxService kshHlhtSbxxService;

    @Autowired
    private KshHlhtZzjgService kshHlhtZzjgService;

    private static Logger log = LoggerFactory.getLogger(KshHlhtSbxxController.class);

    @ApiOperation(value = "分页列表展示", notes = "分页列表展示")
    @RequestMapping(value = "/selectList", method = RequestMethod.POST)
    @ResponseBody
    public RootResult<Object> selectList(@ModelAttribute KshHlhtSbxxInputVo vo) {
        RootResult<Object> r = new RootResult<Object>();
        try {
            PageUtils<KshHlhtSbxx> pageInfo = null;
            List<KshHlhtZzsbgl> zzsb = null;
            vo.setPageNum((vo.getPageNum() - 1) * vo.getPageSize());
            List list = new ArrayList();
            List list1 = new ArrayList();
            List list2 = new ArrayList();
            // 先判断组织结构id是否为空
            if (vo.getZzjgId() != null) {

                List<KshHlhtSbxx> dataList = new ArrayList<KshHlhtSbxx>();
                Integer num = 0;
                // 组织Id去查询设备Id
                if (vo.getLx() == 1) {   // 档案管理查询
                    // zzsb = kshHlhtSbxxService.queryListBySbId(vo.getZzjgId());
                    // 先根据id获取到class_str_id
                    String classStrId = kshHlhtSbxxService.queryByClassId(vo.getZzjgId());
                    if (classStrId != null) {
                        List<KshHlhtZzsbgl> zzId = kshHlhtSbxxService.queryByZzId(classStrId);
                        for (KshHlhtZzsbgl kshHlhtZzsbgl : zzId) {
                            // zzsb = kshHlhtSbxxService.queryListBySbId(kshHlhtZzsbgl.getZzjgId());
                            // 获取组织机构里得class_str_id值
                            /*for (KshHlhtZzsbgl kshHlhtZzsbgl1 : zzsb) {	*/
                            // num += 1;
                            list1.add(kshHlhtZzsbgl.getStrId());
                            num = kshHlhtSbxxService.queryCount(list1);
                            // list.add(kshHlhtZzsbgl1.getSbId());
                            list.add(kshHlhtZzsbgl.getStrId());
                            /* }*/
                        }
                    }

                } else {   // 自定义查询

                    // 110000 是系统管理员得用户id
                    if (vo.getUserId() == 120000) {
                        vo.setUserId(null);
                    }
                    zzsb = kshHlhtSbxxService.queryListByZdySbId(vo.getZzjgId());
                    for (KshHlhtZzsbgl kshHlhtZzsbgl : zzsb) {
                        num += 1;
                        list2.add(kshHlhtZzsbgl.getSbId());
                    }
                }
                if (num >= 1) {

                    Integer pageNum = vo.getPageNum();  // 当前页
                    Integer pageSize = vo.getPageSize();   // 页数

                    List<KshHlhtSbxx> dList = kshHlhtSbxxService.querySbxxList(pageNum, pageSize, list, list2);
                    for (KshHlhtSbxx kshHlhtSbxx : dList) {
                        String result = GetCameraPreviewStatusURL(1, 1, kshHlhtSbxx.getJkdbm(), null, null);
                        if (result != null) {
                            JSONObject jsonString = JSONObject.parseObject(result);
                            JSONObject jsonData = jsonString.getJSONObject("data");
                            JSONArray arrayList = JSON.parseArray(jsonData.getString("list"));
                            Iterator<Object> it = arrayList.iterator();
                            while (it.hasNext()) {
                                JSONObject obj = (JSONObject) it.next();
                                String online = obj.getString("online");
                                if (null != online && online.equals("1")) {   // 1-在线，0-离线   ----->  0-在线  1-离线
                                    kshHlhtSbxx.setSfzx(0);
                                } else {
                                    kshHlhtSbxx.setSfzx(1);
                                }
                            }
                        }
                    }
                    //分页工具类
                    pageInfo = new PageUtils<KshHlhtSbxx>();
                    //填充数据
                    pageInfo.setTotal(num);
                    pageInfo.setList(dList);
                }
            } else {

                // 110000 是系统管理员得用户id
                if (vo.getUserId() == 120000) {
                    vo.setUserId(null);
                }

                //查询总记录数
                Long total = kshHlhtSbxxService.queryTotalCount(vo);
                //分页结果集
                List<KshHlhtSbxx> data = kshHlhtSbxxService.queryList(vo);
                for (KshHlhtSbxx kshHlhtSbxx : data) {
                    String result = GetCameraPreviewStatusURL(1, 1, kshHlhtSbxx.getJkdbm(), null, null);
                    if (result != null) {
                        JSONObject jsonString = JSONObject.parseObject(result);
                        JSONObject jsonData = jsonString.getJSONObject("data");
                        JSONArray arrayList = JSON.parseArray(jsonData.getString("list"));
                        Iterator<Object> it = arrayList.iterator();
                        while (it.hasNext()) {
                            JSONObject obj = (JSONObject) it.next();
                            String online = obj.getString("online");
                            if (null != online && online.equals("1")) {   // 1-在线，0-离线   ----->  0-在线  1-离线
                                kshHlhtSbxx.setSfzx(0);
                            } else {
                                kshHlhtSbxx.setSfzx(1);
                            }
                        }
                    }
                }
                //分页工具类
                pageInfo = new PageUtils<KshHlhtSbxx>();
                //填充数据
                pageInfo.setTotal(total);
                pageInfo.setList(data);
            }
            r.setData(pageInfo);
        } catch (Exception e) {
            r.failure("分页列表异常");
            log.error("分页列表异常", e);
            e.printStackTrace();
        }
        return r;
    }

    @ApiOperation(value = "设备故障分页列表展示", notes = "设备故障分页列表展示")
    @RequestMapping(value = "/selectBadCameraList", method = RequestMethod.POST)
    @ResponseBody
    public RootResult<Object> selectBadCameraList(@ModelAttribute KshHlhtSbxxInputVo vo) {
        RootResult<Object> r = new RootResult<Object>();
        try {
            // 110000 是系统管理员得用户id
            if (vo.getUserId() == 120000) {
                vo.setUserId(null);
            }
            Integer pageSize = vo.getPageSize();
            Integer pageNum = vo.getPageNum();

            Integer total = 0;
            List<KshHlhtSbxx> resultData = new ArrayList<>();
            String result = null;
            if (vo.getLx() == 1) {
                result = GetCameraPreviewStatusURL(1, 1000, null, "0", null);
            } else {
                result = GetCameraPreviewStatusURL(vo.getPageNum(), vo.getPageSize(), null, "0", vo.getZzjgdm());
            }
            if (result != null) {
                JSONObject jsonString = JSONObject.parseObject(result);
                JSONObject jsonData = jsonString.getJSONObject("data");
                JSONArray arrayList = JSON.parseArray(jsonData.getString("list"));
                Iterator<Object> it = arrayList.iterator();
                while (it.hasNext()) {
                    KshHlhtSbxx kshHlhtSbxx = new KshHlhtSbxx();
                    JSONObject obj = (JSONObject) it.next();
                    String indexCode = obj.getString("indexCode");
                    if (StringUtils.isNotBlank(indexCode)) {
                        vo.setPageSize(null);
                        vo.setPageNum(null);
                        vo.setJkdbm(indexCode);
                        List<KshHlhtSbxx> data = kshHlhtSbxxService.queryList(vo);
                        if (null != data && data.size() > 0) {
                            BeanUtils.copyProperties(data.get(0), kshHlhtSbxx);
                        }
                        resultData.add(kshHlhtSbxx);
                    }
                    String online = obj.getString("online");
                    if (StringUtils.isNotBlank(online)) {
                        kshHlhtSbxx.setSfzx(Integer.parseInt(online));
                    }
                }
                total = Integer.parseInt(jsonData.getString("total"));
            }

            if (vo.getLx() == 1) {
                List<Object> list = new ArrayList<Object>();
                int startRow = pageNum * pageSize - pageSize;
				/*LinkedHashMap<String, Long>  resultMap = resultData.stream()
						.collect(Collectors.groupingBy(kshHlhtSbxx->kshHlhtSbxx.getKqmc()==null?"":kshHlhtSbxx.getKqmc()+"_"+kshHlhtSbxx.getZzjgdm(),LinkedHashMap::new,  Collectors.counting()));*/
                Map<String, List<KshHlhtSbxx>> resultMap = resultData.stream().collect(Collectors.groupingBy(kshHlhtSbxx -> kshHlhtSbxx.getKqmc() == null ? "" : kshHlhtSbxx.getKqmc()));
                list = resultMap.entrySet().stream()
                        .skip(startRow).limit(pageSize).collect(Collectors.toList());
                //分页工具类
                PageUtils<Object> pageInfo = new PageUtils<Object>();
                //填充数据
                pageInfo.setTotal(resultMap.size());
                pageInfo.setList(list);
                pageInfo.setChildsTotal(resultData.size());
                r.setData(pageInfo);
            } else {
                //分页工具类
                PageUtils<KshHlhtSbxx> pageInfo = new PageUtils<KshHlhtSbxx>();
                //填充数据
                pageInfo.setTotal(total);
                pageInfo.setList(resultData);
                r.setData(pageInfo);
            }
        } catch (Exception e) {
            r.failure("分页列表异常");
            log.error("分页列表异常", e);
            e.printStackTrace();
        }
        return r;
    }

    @ApiOperation(value = "摄像头故障报警表分页列表展示", notes = "摄像头故障报警表分页列表展示")
    @GetMapping(value = "/selectCameraMalfunctionList/{pageNo}/{pageSize}")
    @ResponseBody
    public RootResult<PageInfo<CameraMalfunctionDO>> selectCameraMalfunctionList(@PathVariable("pageNo") Integer pageNo,
                                                                                 @PathVariable("pageSize") Integer pageSize,
                                                                                 @RequestParam(value = "kqmc", required = false) String kqmc,
                                                                                 @RequestParam(value = "bjrq", required = false) String bjrq,
                                                                                 @RequestParam(value = "kqdm", required = false) String kqdm,
                                                                                 @RequestParam(value = "sbzt", required = false) String sbzt) {
//        PageHelper.startPage(pageNo, pageSize);
        RootResult<PageInfo<CameraMalfunctionDO>> r = new RootResult<>();
        try {
            PageInfo<CameraMalfunctionDO> result = kshHlhtSbxxService.selectCameraMalfunctionList(pageNo, pageSize, kqmc, bjrq, kqdm, sbzt);
            r.setData(null);
            r.setCode(200);
            r.setData(result);
        } catch (Exception e) {
            r.setMsg(e.getMessage());
            e.printStackTrace();
            r.setCode(500);
        }
        return r;
    }

    @ApiOperation(value = "摄像头故障报警表详情分页列表展示", notes = "摄像头故障报警表详情分页列表展示")
    @GetMapping(value = "/selectCameraMalfunctionDetailList/{pageNo}/{pageSize}")
    @ResponseBody
    public RootResult<PageInfo<CameraMalfunctionDTO>> selectCameraMalfunctionDetailList(@PathVariable("pageNo") Integer pageNo,
                                                                                        @PathVariable("pageSize") Integer pageSize,
                                                                                        @RequestParam(value = "kqmc", required = false) String kqmc,
                                                                                        @RequestParam(value = "bjrq", required = false) String bjrq,
                                                                                        @RequestParam(value = "kqdm", required = false) String kqdm,
                                                                                        @RequestParam(value = "sbzt", required = false) String sbzt) {
        PageHelper.startPage(pageNo, pageSize);
        RootResult<PageInfo<CameraMalfunctionDTO>> r = new RootResult<>();
        try {
            PageInfo<CameraMalfunctionDTO> result = kshHlhtSbxxService.selectCameraMalfunctionDetailList(pageNo, pageSize, kqmc, bjrq, kqdm, sbzt);
            r.setData(null);
            r.setCode(200);
            r.setData(result);
        } catch (Exception e) {
            r.setMsg(e.getMessage());
            e.printStackTrace();
            r.setCode(500);
        }
        return r;
    }

    // 获取各个监控点地区菜单
    @ApiOperation(value = "获取各个监控点地区菜单", notes = "获取各个监控点地区菜单")
    @GetMapping(value = "/getCameraPreviewStatusURLMenu")
    @ResponseBody
    public RootResult<Object> getCameraPreviewStatusURLMenu(@RequestParam(value = "pId",required = false) String pId,
                                                            @RequestParam(value = "cookie") String cookie) {
        RootResult<Object> r = new RootResult<>();
        try {
            JSONArray result = kshHlhtSbxxService.getCameraPreviewStatusURLMenu(pId, cookie);
            r.setData(result);
            r.setCode(200);
            System.out.println(r);
        } catch (Exception e) {
            r.setMsg(e.getMessage());
            e.printStackTrace();
            r.setCode(500);
        }
        return r;
    }

    // 每天定时插入监控点信息测试
    @ApiOperation(value = "每天定时插入监控点信息测试", notes = "每天定时插入监控点信息测试")
    @GetMapping(value = "/insertCameraPreviewStatus")
    @ResponseBody
    public RootResult<Object> insertCameraPreviewStatus(@RequestParam(value = "cookie") String cookie,
                                                        @RequestParam(value = "from") String from,
                                                        @RequestParam(value = "to") String to) {
        RootResult<Object> r = new RootResult<>();
        try {
            kshHlhtSbxxService.insertCameraPreviewStatus(cookie, from, to);
            r.setData("添加成功");
            r.setCode(200);
        } catch (Exception e) {
            r.setMsg(e.getMessage());
            e.printStackTrace();
            r.setCode(500);
        }
        return r;
    }

    // 条件分页查询各个监控点信息
    @ApiOperation(value = "条件分页查询各个监控点信息", notes = "条件分页查询各个监控点信息")
    @PostMapping(value = "/queryCameraPreviewStatus")
    @ResponseBody
    public RootResult<PageInfo<CameraStatisticsVO>> queryCameraPreviewStatus(@RequestParam(value = "pageNo") Integer pageNo,
                                                                             @RequestParam(value = "pageSize") Integer pageSize,
                                                                             @RequestBody CameraStatisticsVO vo) {
        RootResult<PageInfo<CameraStatisticsVO>> r = new RootResult<>();
        try {
            PageInfo<CameraStatisticsVO> result = kshHlhtSbxxService.queryCameraPreviewStatus(pageNo, pageSize, vo);
            r.setData(null);
            r.setCode(200);
            r.setData(result);
        } catch (Exception e) {
            r.setMsg(e.getMessage());
            e.printStackTrace();
            r.setCode(500);
        }
        return r;
    }

    // 各个监控点报表导出
    @ApiOperation(value = "各个监控点报表导出", notes = "各个监控点报表导出")
    @PostMapping(value = "/exportCameraPreviewStatus")
    @ResponseBody
    public RootResult<Object> exportCameraPreviewStatus(@RequestBody CameraStatisticsVO vo, HttpServletResponse response) {
        RootResult<Object> r = new RootResult<>();
        try {
            kshHlhtSbxxService.exportCameraPreviewStatus(vo, response);
            r.setData("导出成功");
            r.setCode(200);
        } catch (Exception e) {
            r.setMsg(e.getMessage());
            e.printStackTrace();
            r.setCode(500);
        }
        return r;
    }

    @ApiOperation(value = "摄像头故障报警表插入定时任务测试", notes = "摄像头故障报警表插入定时任务测试")
    @GetMapping(value = "/selectCameraMalfunctionListTest")
    @ResponseBody
    public RootResult<CameraMalfunctionVO> selectCameraMalfunctionListTest() {
        RootResult<CameraMalfunctionVO> r = new RootResult<>();
        try {
            kshHlhtSbxxService.selectCameraMalfunctionListTest();
        } catch (Exception e) {
            r.setMsg(e.getMessage());
            e.printStackTrace();
            r.setCode(500);
        }
        return r;
    }

    @ApiOperation(value = "修改", notes = "修改")
    @RequestMapping(value = "/updateKshHlhtSbxx", method = RequestMethod.POST)
    @ResponseBody
    public RootResult<Object> updateKshHlhtSbxx(@ModelAttribute KshHlhtSbxxInVo vo) {
        RootResult<Object> r = new RootResult<Object>();
        try {
            KshHlhtSbxx bean = BeanUtil.copyObject(vo, KshHlhtSbxx.class);
            kshHlhtSbxxService.updateKshHlhtSbxx(bean);
        } catch (Exception e) {
            log.error("修改异常", e);
            r.failure("修改异常");
            e.printStackTrace();
        }
        return r;
    }

    @ApiOperation(value = "详情", notes = "详情")
    @RequestMapping(value = "/view", method = RequestMethod.POST)
    @ResponseBody
    public RootResult<Object> viewKshHlhtSbxx(Integer id) {
        RootResult<Object> r = new RootResult<Object>();
        try {
            KshHlhtSbxx sbxx = kshHlhtSbxxService.viewKshHlhtSbxx(id);
            String result = GetCameraPreviewStatusURL(1, 1, sbxx.getJkdbm(), null, null);
            if (result != null) {
                JSONObject jsonString = JSONObject.parseObject(result);
                JSONObject jsonData = jsonString.getJSONObject("data");
                JSONArray arrayList = JSON.parseArray(jsonData.getString("list"));
                Iterator<Object> it = arrayList.iterator();
                while (it.hasNext()) {
                    JSONObject obj = (JSONObject) it.next();
                    String online = obj.getString("online");
                    if (online.equals("1")) {   // 1-在线，0-离线   ----->  0-在线  1-离线
                        sbxx.setSfzx(0);
                    } else {
                        sbxx.setSfzx(1);
                    }
                }
            }
            r.setData(sbxx);
        } catch (Exception e) {
            log.error("修改异常", e);
            r.failure("修改异常");
            e.printStackTrace();
        }
        return r;
    }

    @ApiOperation(value = "设备信息导出excel", notes = "设备信息导出excel")
    @RequestMapping(value = "/sbxxExportExcel", method = {RequestMethod.POST, RequestMethod.GET})
    @ResponseBody
    public void sbxxExportExcel(@ModelAttribute KshHlhtSbxxInputVo vo, HttpServletResponse response, HttpServletRequest request) {
        try {
            // kshHlhtSbxxService.sbxxExportExcel(vo,response);
            RootResult<Object> r = new RootResult<Object>();
            //获得模版
            String tempFileName = request.getSession().getServletContext().getRealPath("//model");
            //将结果放入这个list中
            Date date = new Date();
            SimpleDateFormat simpl = new SimpleDateFormat("yyyyMMddHHmmss");
            String currntTime = simpl.format(date);
            tempFileName += "//采集建档维护.xls";
            //导出列表名
            String fileName = currntTime + "列表.xls";
            //文件名称统一编码格式
            fileName = URLEncoder.encode(fileName, "utf-8");
            //生成的导出文件
            File destFile = File.createTempFile(fileName, ".xls");
            //transformer转到Excel
            XLSTransformer transformer = new XLSTransformer();
            BufferedInputStream bis = null;
            BufferedOutputStream bos = null;
            try {

                List list = new ArrayList<>();
                String classStrId = kshHlhtSbxxService.queryByClassId(vo.getZzjgId());
                if (classStrId != null) {
                    List<KshHlhtZzsbgl> zzId = kshHlhtSbxxService.queryByZzId(classStrId);
                    for (KshHlhtZzsbgl kshHlhtZzsbgl : zzId) {
                        list.add(kshHlhtZzsbgl.getStrId());
                    }
                }
                vo.setList(list);

                Object data = kshHlhtSbxxService.sbxxExportExcel(vo).getData();
                JSONObject obj = JSONObject.parseObject(JSONObject.toJSONString(data));

                obj.put("data", obj.getJSONArray("data"));
                //将数据添加到模版中生成新的文件
                transformer.transformXLS(tempFileName, (Map<String, Object>) obj, destFile.getAbsolutePath());

                System.out.println((Map<String, Object>) data);

                //将文件输入
                InputStream inputStream = new FileInputStream(destFile);
                // 设置参数，可以打开下载页面
                response.reset();
                //设置响应文本格式
                response.setContentType("application/vnd.ms-excel;charset=utf-8");
//    			response.setContentType("text/html;charset=UTF-8");
                response.setHeader("Content-Disposition", "attachment;filename=" + new String((fileName).getBytes(), "iso-8859-1"));
                //将文件输出到页面
                ServletOutputStream out = response.getOutputStream();
                bis = new BufferedInputStream(inputStream);
                bos = new BufferedOutputStream(out);
                byte[] buff = new byte[2048];
                int bytesRead;
                // 根据读取并写入
                while (-1 != (bytesRead = bis.read(buff, 0, buff.length))) {
                    bos.write(buff, 0, bytesRead);
                }

            } catch (Exception e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            } finally {
                //使用完成后关闭流
                try {
                    if (bis != null)
                        bis.close();
                    if (bos != null)
                        bos.close();
                } catch (IOException e) {

                }
            }
        } catch (Exception e) {
            log.error("下载excel异常", e);
            e.printStackTrace();
        }
    }

    @ApiOperation(value = "导入(设备信息维护)", notes = "导入(设备信息维护)")
    @RequestMapping(value = "/impSbxxInfo", method = RequestMethod.POST)
    public @ResponseBody RootResult<KshHlhtSbxx> impSbxxInfo(@RequestParam MultipartFile file, KshHlhtSbxxInVo vo, HttpServletRequest request)
            throws Exception {
        return kshHlhtSbxxService.impSbxxInfo(file, vo);
    }

    @ApiOperation(value = "省", notes = "省")
    @RequestMapping(value = "/querySheng", method = RequestMethod.POST)
    @ResponseBody
    public RootResult<Object> querySheng(String stdcode) {
        RootResult<Object> r = new RootResult<Object>();
        try {
            List<KshHlhtXzqh> dataList = kshHlhtSbxxService.querySheng(stdcode);
            r.setData(dataList);
        } catch (Exception e) {
            log.error("省查询异常", e);
            r.failure("省查询异常");
            e.printStackTrace();
        }
        return r;
    }

    @ApiOperation(value = "市", notes = "市")
    @RequestMapping(value = "/queryShi", method = RequestMethod.POST)
    @ResponseBody
    public RootResult<Object> queryShi(String stdcode) {
        RootResult<Object> r = new RootResult<Object>();
        try {
            List<KshHlhtXzqh> dataList = kshHlhtSbxxService.queryShi(stdcode);
            r.setData(dataList);
        } catch (Exception e) {
            log.error("市查询异常", e);
            r.failure("市查询异常");
            e.printStackTrace();
        }
        return r;
    }

    @ApiOperation(value = "县", notes = "县")
    @RequestMapping(value = "/queryXian", method = RequestMethod.POST)
    @ResponseBody
    public RootResult<Object> queryXian(String stdcode) {
        RootResult<Object> r = new RootResult<Object>();
        try {
            List<KshHlhtXzqh> dataList = kshHlhtSbxxService.queryXian(stdcode);
            r.setData(dataList);
        } catch (Exception e) {
            log.error("县查询异常", e);
            r.failure("县查询异常");
            e.printStackTrace();
        }
        return r;
    }

    public static String GetCameraPreviewStatusURL(Integer pageNo, Integer pageSize, String indexCodes, String status, String regionId) {

        /**
         * STEP1：设置平台参数，根据实际情况,设置host appkey appsecret 三个参数.
         */
        // 外网的
		/*ArtemisConfig.host = "106.3.145.75:443"; // artemis网关服务器ip端口
		ArtemisConfig.appKey = "26469219"; // 秘钥appkey
		ArtemisConfig.appSecret = "w4GKdMLvVTxDLUgtzV2L";*/// 秘钥appSecret

        // 内网的
		/*ArtemisConfig.host = "172.16.13.3:443"; // artemis网关服务器ip端口
		ArtemisConfig.appKey = "26469219"; // 秘钥appkey    28116466
		ArtemisConfig.appSecret = "w4GKdMLvVTxDLUgtzV2L";// 秘钥appSecret   W9zihM0hNRsnNic3zuKM
*/
        ArtemisConfig.host = "10.69.3.1:443"; // artemis网关服务器ip端口
        ArtemisConfig.appKey = "24012924"; // 秘钥appkey   28116466
        ArtemisConfig.appSecret = "uHzSYRUJpnCVCJSIEUWc";// 秘钥appSecret   W9zihM0hNRsnNic3zuKM

        /**
         * STEP2：设置OpenAPI接口的上下文
         */
        final String ARTEMIS_PATH = "/artemis";

        String body = null;

        String contentType = null;

        Map path = new HashMap();

        /**
         * STEP3：设置接口的URI地址
         */
        final String previewURLsApi = ARTEMIS_PATH +
                "/api/nms/v1/online/camera/get";     // 获取分页监控点资源
        path = new HashMap(2) {
            {
                put("https://", previewURLsApi);//根据现场环境部署确认是http还是https
            }
        };

        /**
         * STEP4：设置参数提交方式
         */
        contentType = "application/json";

        /**
         * STEP5：组装请求参数
         */
        JSONObject jsonBody = new JSONObject();

        // 获取分页监控点资源参数

        jsonBody.put("pageNo", pageNo);
        jsonBody.put("pageSize", pageSize);
        if (StringUtils.isNotBlank(indexCodes)) {
            jsonBody.put("indexCodes", "[" + indexCodes + "]");
        }
        if (StringUtils.isNotBlank(status)) {
            jsonBody.put("status", "" + status + "");
        }
        if (StringUtils.isNotBlank(regionId)) {
            jsonBody.put("regionId", "" + regionId + "");
        }
        body = jsonBody.toJSONString().replace("\"[", "[\"").replace("]\"", "\"]");

        /**
         * STEP6：调用接口
         */
        String result = ArtemisHttpUtil.doPostStringArtemis(path, body, null, null, contentType, null);// post请求application/json类型参数
        return result;
    }

    public static String GetCameraPreviewURL(ControllingRequest controllingRequest, Integer type) {

        /**
         * STEP1：设置平台参数，根据实际情况,设置host appkey appsecret 三个参数.
         */
        // 外网的
		/*ArtemisConfig.host = "106.3.145.75:443"; // artemis网关服务器ip端口
		ArtemisConfig.appKey = "26469219"; // 秘钥appkey
		ArtemisConfig.appSecret = "w4GKdMLvVTxDLUgtzV2L";// 秘钥appSecret
*/

        // 内网的
		/*ArtemisConfig.host = "172.16.13.3:443"; // artemis网关服务器ip端口
		ArtemisConfig.appKey = "26469219"; // 秘钥appkey    28116466
		ArtemisConfig.appSecret = "w4GKdMLvVTxDLUgtzV2L";// 秘钥appSecret   W9zihM0hNRsnNic3zuKM
*/

        // 政务外网
		/*ArtemisConfig.host = "192.168.7.101:443"; // artemis网关服务器ip端口
		ArtemisConfig.appKey = "22129988"; // 秘钥appkey    28116466
		ArtemisConfig.appSecret = "vHvyP8OJV5uLoApXMaGS";*/// 秘钥appSecret   W9zihM0hNRsnNic3zuKM

        ArtemisConfig.host = "10.69.3.1:443"; // artemis网关服务器ip端口
        ArtemisConfig.appKey = "24012924"; // 秘钥appkey   28116466
        ArtemisConfig.appSecret = "uHzSYRUJpnCVCJSIEUWc";// 秘钥appSecret   W9zihM0hNRsnNic3zuKM

        /**
         * STEP2：设置OpenAPI接口的上下文
         */
        final String ARTEMIS_PATH = "/artemis";

        String body = null;

        String contentType = null;

        Map path = new HashMap();

        if (type == 1) {

            /**
             * STEP3：设置接口的URI地址
             */
            final String previewURLsApi = ARTEMIS_PATH +
                    "/api/video/v1/ptzs/controlling";

            path = new HashMap(2) {
                {
                    put("https://", previewURLsApi);//根据现场环境部署确认是http还是https
                }
            };

            /**
             * STEP4：设置参数提交方式
             */
            contentType = "application/json";

            /**
             * STEP5：组装请求参数
             */

            body = JSON.toJSONString(controllingRequest);

        } else {

            /**
             * STEP3：设置接口的URI地址
             */
            final String previewURLsApi = ARTEMIS_PATH +
                    "/api/video/v1/presets/searches";

            path = new HashMap(2) {
                {
                    put("https://", previewURLsApi);//根据现场环境部署确认是http还是https
                }
            };

            /**
             * STEP4：设置参数提交方式
             */
            contentType = "application/json";

            /**
             * STEP5：组装请求参数
             */

            body = JSON.toJSONString(controllingRequest);

        }

        /**
         * STEP6：调用接口
         */
        String result = ArtemisHttpUtil.doPostStringArtemis(path, body, null, null,
                contentType, null);// post请求application/json类型参数
        return result;
    }

    @ApiOperation(value = "云台控制", notes = "云台控制")
    @RequestMapping(value = "/yuntaiControl", method = RequestMethod.POST)
    @ResponseBody
    public RootResult<Object> yuntaiControl(ControllingRequest controllingRequest) {
        RootResult<Object> r = new RootResult<Object>();
        try {

            Integer presetIndex = 0;

            if (controllingRequest.getSbId() != null) {

                // 先根据设备Id查询到监控点编码
                KshHlhtSbxx info = kshHlhtSbxxService.viewKshHlhtSbxx(controllingRequest.getSbId());

                if (info != null) {

                    controllingRequest.setCameraIndexCode(info.getJkdbm());  // 获取监控点编码

                    String resultData = GetCameraPreviewURL(controllingRequest, 2);

                    JSONObject objData = JSONObject.parseObject(resultData);

                    JSONObject jsonObjData = objData.getJSONObject("data");

                    JSONArray arrayList = JSON.parseArray(jsonObjData.getString("list"));

                    Iterator<Object> it = arrayList.iterator();

                    while (it.hasNext()) {

                        JSONObject obj = (JSONObject) it.next();

                        presetIndex = obj.getInteger("presetPointIndex");

                    }

                }


            } else {

                controllingRequest.setCameraIndexCode(controllingRequest.getCameraIndexCode());  // 获取监控点编码

                String resultData = GetCameraPreviewURL(controllingRequest, 2);

                JSONObject objData = JSONObject.parseObject(resultData);

                JSONObject jsonObjData = objData.getJSONObject("data");

                JSONArray arrayList = JSON.parseArray(jsonObjData.getString("list"));

                Iterator<Object> it = arrayList.iterator();

                while (it.hasNext()) {

                    JSONObject obj = (JSONObject) it.next();

                    presetIndex = obj.getInteger("presetPointIndex");

                }

            }

            controllingRequest.setPresetIndex(presetIndex);  // 预置点编码

            String resultData = GetCameraPreviewURL(controllingRequest, 1);

            r.setData(resultData);

        } catch (Exception e) {
            log.error("云台控制异常", e);
            r.failure("云台控制异常");
            e.printStackTrace();
        }
        return r;
    }

    @ApiOperation(value = "库区编码查询摄像头", notes = "库区编码查询摄像头")
    @RequestMapping(value = "/queryKqbm", method = RequestMethod.POST)
    @ResponseBody
    public RootResult<Object> queryKqbm(String kqbm) {
        RootResult<Object> r = new RootResult<Object>();
        try {
            List<KshHlhtXzqh> data = kshHlhtSbxxService.queryKqbm(kqbm);
            r.setData(data);
        } catch (Exception e) {
            log.error("库区编码查询摄像头异常", e);
            r.failure("库区编码查询摄像头异常");
            e.printStackTrace();
        }
        return r;
    }

	/*@ApiOperation(value="省市县数形结构展示", notes="省市县数形结构展示")
    @RequestMapping(value = "/queryShengAndShi",method = RequestMethod.POST)
	@ResponseBody
	public RootResult<List<KshHlhtSheng>> queryShengAndShi() {
		RootResult<List<KshHlhtSheng>> r = new RootResult<List<KshHlhtSheng>>();
		try {

			List<KshHlhtSheng> resultList = new ArrayList<KshHlhtSheng>();

			// 查询父节点Id
			List<KshHlhtSheng> nodeList = kshHlhtSbxxService.queryParentId();
			for (KshHlhtSheng treeNode : nodeList) {
				if(treeNode.getValue() != 0) {
					KshHlhtSheng node = getTree(treeNode);
					if(node != null) {
						resultList.add(node);
					}
				}
			}

			r.setData(resultList);

		}catch (Exception e) {
			r.failure("分页列表异常");
			log.error("分页列表异常", e);
			e.printStackTrace();
		}
		return r;
	}

	private KshHlhtSheng getTree(KshHlhtSheng treeNode) {
		// 所有子类得数据
		List<KshHlhtSheng> childList = kshHlhtSbxxService.queryChildListById(treeNode.getValue());
		if(childList != null) {
			treeNode.setChildren(childList);
			for(KshHlhtSheng childNode : childList) {
				if(childNode.getValue() != 0) {
					getTree(childNode);
				}
			}
		}
		return treeNode;
	}*/

    @ApiOperation(value = "插入(保存按钮把shzt传0给后台,保存并提交把shzt传1给后台)(作废)",
            notes = "插入(保存按钮把shzt传0给后台,保存并提交把shzt传1给后台)(作废)")
    @RequestMapping(value = "/insertKshHlhtSbxx", method = RequestMethod.POST)
    @ResponseBody
    public RootResult<Object> insertKshHlhtSbxx(@ModelAttribute KshHlhtSbxxInVo vo) {
        RootResult<Object> r = new RootResult<Object>();
        try {
            KshHlhtSbxx bean = BeanUtil.copyObject(vo, KshHlhtSbxx.class);
            kshHlhtSbxxService.insertKshHlhtSbxx(bean);
        } catch (Exception e) {
            log.error("插入异常", e);
            r.failure("插入异常");
            e.printStackTrace();
        }
        return r;
    }

    @ApiOperation(value = "模板下载(设备信息维护)(作废)", notes = "模板下载(设备信息维护)(作废)")
    @RequestMapping(value = "/impSbxxInfoModel", method = RequestMethod.GET)
    public void impSbxxInfoModel(HttpServletResponse response) throws Exception {
        List<String> header = new ArrayList<String>();
        header.add("设备ID");
        header.add("企业名称");
        header.add("型号");
        header.add("企业代码");
        header.add("IP地址");
        header.add("单位地址");
        header.add("IPv6地址");
        header.add("统一信用代码");
        header.add("端口号");
        header.add("经度");
        header.add("纬度");
        header.add("用户账号");
        header.add("设备序列号");
        header.add("口令");
        header.add("设备序号");
        header.add("库区类型");
        header.add("库区编码");
        header.add("仓房编码");
        header.add("安装位置类型");
        header.add("设备功能类型");
        header.add("监视区域说明");
        ExcelModelUtils.downloadModel(response, header, "采集建档模板");
    }

}
