package com.jusfoun.ydylsz.controller;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.hikvision.artemis.sdk.ArtemisHttpUtil;
import com.hikvision.artemis.sdk.config.ArtemisConfig;
import com.jusfoun.ydylsz.pojo.KshHlhtSbxx;
import com.jusfoun.ydylsz.pojo.KshHlhtZzsbgl;
import com.jusfoun.ydylsz.pojo.NodeTemp;
import com.jusfoun.ydylsz.pojo.TreeNode;
import com.jusfoun.ydylsz.service.KshHlhtSbxxService;
import com.jusfoun.ydylsz.service.KshHlhtZzjgService;
import com.jusfoun.ydylsz.util.MenuTreeUtil;
import com.jusfoun.ydylsz.vo.in.KshHlhtScfzInVo;
import com.jusfoun.ydylsz.vo.out.base.RootResult;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

@Api(description="组织机构和设备信息接口推送")
@Controller
@RequestMapping(value = "/kshHlhtZzjgAndSbxxPush")
@CrossOrigin
public class KshHlhtZzjgPush {
	
	@Autowired
    private KshHlhtZzjgService kshHlhtZzjgService;
	
	@Autowired
	private KshHlhtSbxxService kshHlhtSbxxService;
	
	public String GetCameraPreviewURL(Integer pageNo,Integer pageSize,Integer type,String indexCodes) {
	/**  
	* STEP1：设置平台参数，根据实际情况,设置host appkey appsecret 三个参数.  
	*/  
	ArtemisConfig.host = "106.3.145.75:443"; // artemis网关服务器ip端口  
	ArtemisConfig.appKey = "28116466"; // 秘钥appkey   28116466
	ArtemisConfig.appSecret = "W9zihM0hNRsnNic3zuKM";// 秘钥appSecret   W9zihM0hNRsnNic3zuKM

	// 政务外网 
	/*ArtemisConfig.host = "192.168.7.101:443"; // artemis网关服务器ip端口  
	ArtemisConfig.appKey = "22129988"; // 秘钥appkey    28116466
	ArtemisConfig.appSecret = "vHvyP8OJV5uLoApXMaGS";// 秘钥appSecret   W9zihM0hNRsnNic3zuKM	
*/		
	/**  
	* STEP2：设置OpenAPI接口的上下文  
	*/  
	final String ARTEMIS_PATH = "/artemis";  
	
	String body = null;
	
	String contentType = null;
	
	Map  path = new HashMap();
	
	if(type == 1) {   // 获取区域列表
		/**  
		* STEP3：设置接口的URI地址  
		*/  
		final String previewURLsApi = ARTEMIS_PATH +
		"/api/irds/v2/region/nodesByParams";     // 获取区域列表
		path = new HashMap (2) {  
		{  
		put("https://", previewURLsApi);//根据现场环境部署确认是http还是https  
		}  
		};  

		/**  
		* STEP4：设置参数提交方式  
		*/  
		contentType = "application/json";  

		/**  
		* STEP5：组装请求参数  
		*/  
		JSONObject jsonBody = new JSONObject();   
		
		// 获取区域列表所要传的参数
		jsonBody.put("pageNo", pageNo);  
		jsonBody.put("pageSize", pageSize);
		jsonBody.put("resourceType", "camera");
		jsonBody.put("cascadeFlag", 0);
		
		
		body = jsonBody.toJSONString(); 
	}else if(type == 2){
		
		/**  
		* STEP3：设置接口的URI地址  
		*/  
		final String previewURLsApi = ARTEMIS_PATH +
		"/api/resource/v1/cameras";     // 获取分页监控点资源
		path = new HashMap (2) {  
		{  
		put("https://", previewURLsApi);//根据现场环境部署确认是http还是https  
		}  
		};  

		/**  
		* STEP4：设置参数提交方式  
		*/
		contentType = "application/json";  

		/**  
		* STEP5：组装请求参数  
		*/ 
		JSONObject jsonBody = new JSONObject();   
		
		// 获取分页监控点资源参数
		jsonBody.put("pageNo", pageNo);  
		jsonBody.put("pageSize", pageSize);
		
		
		body = jsonBody.toJSONString();  
	}else if(type == 4){
		/**  
		* STEP3：设置接口的URI地址  
		*/  
		final String previewURLsApi = ARTEMIS_PATH +
		"/api/resource/v1/regions/regionIndexCode/cameras";     // 获取分页监控点资源
		path = new HashMap (2) {  
		{  
		put("https://", previewURLsApi);//根据现场环境部署确认是http还是https  
		}  
		};  

		/**  
		* STEP4：设置参数提交方式  
		*/
		contentType = "application/json";  

		/**  
		* STEP5：组装请求参数  
		*/ 
		JSONObject jsonBody = new JSONObject();   
		
		// 获取分页监控点资源参数
		jsonBody.put("regionIndexCode",indexCodes);
		jsonBody.put("pageNo", pageNo);  
		jsonBody.put("pageSize", pageSize);
				
		body = jsonBody.toJSONString();  
	}else{
		
		/**  
		* STEP3：设置接口的URI地址  
		*/  
		final String previewURLsApi = ARTEMIS_PATH +
		"/api/nms/v1/online/camera/get";     // 获取分页监控点资源
		path = new HashMap (2) {  
		{  
		put("https://", previewURLsApi);//根据现场环境部署确认是http还是https  
		}  
		};  

		/**  
		* STEP4：设置参数提交方式  
		*/
		contentType = "application/json"; 
		
		/**  
		* STEP5：组装请求参数  
		*/ 
		JSONObject jsonBody = new JSONObject();   
		
		// 获取分页监控点资源参数
		
		jsonBody.put("pageNo", pageNo);  
		jsonBody.put("pageSize", pageSize);
		jsonBody.put("indexCodes", "["+indexCodes+"]");
		body = jsonBody.toJSONString().replace("\"[", "[\"").replace("]\"", "\"]"); 

	}

	
	/**  
	* STEP6：调用接口  
	*/  
	String result = ArtemisHttpUtil.doPostStringArtemis(path, body, null, null,contentType , null);// post请求application/json类型参数  
	return result;  
	}
	
	@ApiOperation(value="监控点在线状态", notes="监控点在线状态")
    @RequestMapping(value = "/online",method = RequestMethod.POST)
	@ResponseBody
	public RootResult<Object> online(){
		RootResult<Object> r = new RootResult<Object>();
		try {
			Integer pageNo = 1;
			Integer pageSize = 1;
			Integer type = 3;  //获取分页信息监控点信息
			String indexCodes = "61010401581314002053";
			String result = GetCameraPreviewURL(pageNo,pageSize,type,indexCodes);
			JSONObject jsonString = JSONObject.parseObject(result);
			JSONObject jsonData = jsonString.getJSONObject("data");
			JSONArray arrayList = JSON.parseArray(jsonData.getString("list"));
			Iterator<Object> it = arrayList.iterator();
			while (it.hasNext()) {
				JSONObject obj = (JSONObject) it.next();
				String online = obj.getString("online");
				System.out.println("----" + online);
			}
		}catch(Exception e) {
			e.printStackTrace();
		}
		return r;
	}
	
	@ApiOperation(value="根据区域编号获取下级监控点列表", notes="根据区域编号获取下级监控点列表")
    @RequestMapping(value = "/Test",method = RequestMethod.POST)
	@ResponseBody
	public RootResult<Object> Test(String indexCodes){
		RootResult<Object> r = new RootResult<Object>();
		try {
			Integer pageNo = 1;
			Integer pageSize = 10;
			Integer type = 4;  //获取分页信息监控点信息
			String result = GetCameraPreviewURL(pageNo,pageSize,type,indexCodes);
			JSONObject jsonString = JSONObject.parseObject(result);
			JSONObject jsonData = jsonString.getJSONObject("data");
			JSONArray arrayList = JSON.parseArray(jsonData.getString("list"));
			System.out.println("获取数据为：" + arrayList);
		}catch(Exception e) {
			e.printStackTrace();
		}
		return r;
	}
	
	
	/*@ApiOperation(value="组织机构信息推送(新方法优化)", notes="组织机构信息推送(新方法优化)")
    @RequestMapping(value = "/NewzzjgPush",method = RequestMethod.POST)
	@ResponseBody
	public RootResult<Object> NewzzjgPush(String indexCode){
		RootResult<Object> r = new RootResult<Object>();
		try {
			
			List<NodeTemp> nodeTemp = kshHlhtZzjgService.queryListTemp(indexCode);
			
			KshHlhtScfzInVo invo = new KshHlhtScfzInVo();
			
			for (NodeTemp node : nodeTemp) {
				invo.setZzmc(node.getName());
				invo.setZId(node.getZid());
				invo.setFId(node.getFid());
				if(node.getName().equals("国家粮食局")) {
					invo.setZzmc("国家粮食和物资储备局");
					invo.setIntzId(110000);
					invo.setIntfId(0);
				}else if(node.getFid().equals("root000000")){					
					invo.setIntzId(Integer.parseInt(node.getZid()));
					invo.setIntfId(110000);
				}else {
					if(node.getZid().length() == 20) {	
						if(node.getFid().length() == 20) {
							invo.setIntzId(Integer.parseInt(node.getZid().substring(0, 6) + node.getZid().substring(18, 20)));
							invo.setIntfId(Integer.parseInt(node.getFid().substring(0, 6) + node.getFid().substring(18, 20)));
						}else {
							invo.setIntzId(Integer.parseInt(node.getZid().substring(0, 6) + node.getZid().substring(18, 20)));
							invo.setIntfId(Integer.parseInt(node.getFid()));
						}						
					}else{
						if(node.getFid().length() == 20) {
							invo.setIntzId(Integer.parseInt(node.getZid()));
							invo.setIntfId(Integer.parseInt(node.getFid().substring(0, 6) + node.getFid().substring(18, 20)));
						}else {
							invo.setIntzId(Integer.parseInt(node.getZid()));
							invo.setIntfId(Integer.parseInt(node.getFid()));
						}						
					}
				}	
				
				System.out.println("组织机构名称" + "------" + invo.getZzmc() + "------" + "zid" + "------" + invo.getIntzId() + "------" +"fid" + "------" + invo.getIntfId());
			}			
			
		}catch (Exception e) {
			r.failure("推送信息异常");
			e.printStackTrace();
		}
		return r;
	}*/
	
}
