package com.jusfoun.ydylsz.mapper;

import com.jusfoun.ydylsz.vo.CameraAreas;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;
import tk.mybatis.mapper.common.BaseMapper;

import java.util.List;

/**
 * @Classname CameraAreaMapper
 * @Description TODO
 * @Date 2023/12/14 15:47
 * @Created by rising123sun
 */
@Mapper
public interface CameraAreaMapper extends BaseMapper<CameraAreas> {
    @Insert("insert into camera_areas(id,text,label,pId,cls,leaf,isDefault,iscascade,isParent,state,org_code) values(#{id},#{text},#{label},#{pId},#{cls},#{leaf},#{isDefault},#{iscascade},#{isParent},#{state},#{orgCode})")
    void insertCameraArea(CameraAreas cameraArea);

    @Select("select * from usercenter:sys_org_relate where org_code != 'LS001' and org_code != 'LS001019' and org_code != 'LS001020' and org_code != 'LS001021' and org_code != relate_org order by org_code asc,relate_org asc")
    List<CameraAreas> selectAllCameraAreas();

    @Select("select * from usercenter:sys_org_relate where org_code = #{org_code} order by org_code asc,relate_org asc")
    List<CameraAreas> selectCameraAreasByOrgCode(String orgCode);

    @Select("select org_code from usercenter:sys_org_relate where relate_org_name = #{text} order by org_code asc,relate_org asc")
    String selectOrgCodeFormSys(String text);

    @Select("select * from usercenter:sys_org_relate sor1 where sor1.org_code not in(select sor2.relate_org from usercenter:sys_org_relate sor2 where sor2.org_code != sor2.relate_org) and sor1.org_code = sor1.relate_org order by org_code asc,relate_org asc")
    List<CameraAreas> selectRootCameraAreas();

    @Select("select * from usercenter:sys_org_relate where org_code = #{orgCode} and relate_org = #{orgCode} order by org_code asc,relate_org asc")
    CameraAreas selectCurrentCameraArea(String orgCode);

    @Select("select * from usercenter:sys_org_relate where org_code = #{orgCode} and relate_org = '看所有' order by org_code asc,relate_org asc")
    CameraAreas selectRootCameraArea(String orgCode);

    @Select("select * from usercenter:sys_org_relate where relate_org = #{orgCode} order by org_code asc,relate_org asc")
    List<CameraAreas>  selectKqCameraArea(String orgCode);
}
