package com.jusfoun.ydylsz.service;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.jusfoun.ydylsz.mapper.DXPPointMapper;
import com.jusfoun.ydylsz.vo.DXPCFXXVO;
import com.jusfoun.ydylsz.vo.KqImageVO;
import com.jusfoun.ydylsz.vo.PointVO;
import com.jusfoun.ydylsz.vo.TreeNode;
import org.json.JSONArray;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import java.util.List;

@Service
public class DXPPointService {

    @Autowired
    private DXPPointMapper dxpPointMapper;

    public void savePoint(PointVO point) {
        /*PointVO pointVO = dxpPointMapper.findPoint(point.getIndex());
        if(pointVO!=null){
            dxpPointMapper.updatePoint(point);
        }else {
            dxpPointMapper.savePoint(point);
        }*/
    	String strpoint = point.getStrPoint();
    	if(strpoint != null) {
			JSONArray jsonArr = new JSONArray(strpoint);
			for(int i=0;i<jsonArr.length();i++) {
				JSONObject obj = jsonArr.getJSONObject(i);
				String index = obj.optString("index", null);
				String kqbh = obj.optString("kqbh", null);	
				PointVO pointVO = dxpPointMapper.findPoint(index,kqbh);
				if(pointVO!=null){
					PointVO vo = new PointVO();					
					vo.setIndex(obj.optString("index", null));					
					vo.setKqbh(obj.optString("kqbh", null));					
					vo.setStyles(obj.optString("styles", null));					
					vo.setAreaItem(obj.optString("areaItem", null));					
					vo.setType(obj.optString("type", null));				
					vo.setCTime(obj.optString("cTime", null));				
					vo.setUTime(obj.optString("uTime", null));	
					vo.setName(obj.optString("name", null));
					dxpPointMapper.updatePoint(vo);
				}else {
				    // 先把之前的数据清掉
				    // dxpPointMapper.deletePointNew(obj.optString("kqbh", null),obj.optString("type", null));
					PointVO vo = new PointVO();
					vo.setIndex(obj.optString("index", null));					
					vo.setKqbh(obj.optString("kqbh", null));					
					vo.setStyles(obj.optString("styles", null));					
					vo.setAreaItem(obj.optString("areaItem", null));					
					vo.setType(obj.optString("type", null));				
					vo.setCTime(obj.optString("cTime", null));				
					vo.setUTime(obj.optString("uTime", null));	
					vo.setName(obj.optString("name", null));
					dxpPointMapper.savePoint(vo);
				}	
			}
    	}
    	
    	String strpoint1 = point.getStr1Point();
    	if(strpoint1 != null) {
			JSONArray jsonArr = new JSONArray(strpoint1);
			for(int i=0;i<jsonArr.length();i++) {
				JSONObject obj = jsonArr.getJSONObject(i);
				   String index = obj.optString("index", null);
				   String kqbh = obj.optString("kqbh", null);
				   PointVO pointVO = dxpPointMapper.findPoint(index,kqbh);
				   if(pointVO!=null){
					PointVO vo = new PointVO();					
					vo.setIndex(obj.optString("index", null));					
					vo.setKqbh(obj.optString("kqbh", null));					
					vo.setStyles(obj.optString("styles", null));					
					vo.setAreaItem(obj.optString("areaItem", null));					
					vo.setType(obj.optString("type", null));				
					vo.setCTime(obj.optString("cTime", null));				
					vo.setUTime(obj.optString("uTime", null));	
					vo.setName(obj.optString("name", null));
					dxpPointMapper.updatePoint(vo);
				}else {
					// 先把之前的数据清掉
				    // dxpPointMapper.deletePointNew(obj.optString("kqbh", null),obj.optString("type", null));
					PointVO vo = new PointVO();
					vo.setIndex(obj.optString("index", null));					
					vo.setKqbh(obj.optString("kqbh", null));					
					vo.setStyles(obj.optString("styles", null));					
					vo.setAreaItem(obj.optString("areaItem", null));					
					vo.setType(obj.optString("type", null));				
					vo.setCTime(obj.optString("cTime", null));				
					vo.setUTime(obj.optString("uTime", null));	
					vo.setName(obj.optString("name", null));
					dxpPointMapper.savePoint(vo);
				}	
			}
    	}
    	
    	String delPoint = point.getDelPoint();
    	if(delPoint != null) {
    		JSONArray jsonArr = new JSONArray(delPoint);
			for(int i=0;i<jsonArr.length();i++) {
				JSONObject obj = jsonArr.getJSONObject(i);
				String index = obj.optString("index", null);
				String kqbh = obj.optString("kqbh", null);
				dxpPointMapper.deletePointNew(index,kqbh);
			}
    	}
    	
    	String del1Point = point.getDel1Point();
    	if(del1Point != null) {
    		JSONArray jsonArr = new JSONArray(del1Point);
			for(int i=0;i<jsonArr.length();i++) {
				JSONObject obj = jsonArr.getJSONObject(i);
				String index = obj.optString("index", null);
				String kqbh = obj.optString("kqbh", null);
				dxpPointMapper.deletePointNew(index,kqbh);
			}
    	}
    	
    }

    public void updatePoint(PointVO point) {
        dxpPointMapper.updatePoint(point);
    }

    public void deletePoint(String kqbh) {
        dxpPointMapper.deletePoint(kqbh);
    }

    public List<PointVO> pointDetail(String kqbh, String type) {
        List<PointVO> list = dxpPointMapper.pointDetail(kqbh,type);
        return list;
    }

    public void saveImage(KqImageVO kqImageVO) {
        KqImageVO kqImage = dxpPointMapper.imageDetail(kqImageVO.getKqbh());
        if(kqImage!=null){
            if(kqImageVO.getPath().equals(kqImage.getPath())){
            }else{
                dxpPointMapper.deletePoint(kqImageVO.getKqbh());
            }
            dxpPointMapper.updateImage(kqImageVO);
        }else {
            dxpPointMapper.saveImage(kqImageVO);
        }
    }

    public void updateImage(KqImageVO kqImageVO) {
        dxpPointMapper.updateImage(kqImageVO);
    }

    public KqImageVO imageDetail(String kqbh) {
        KqImageVO kqImageVO = dxpPointMapper.imageDetail(kqbh);
        return  kqImageVO;
    }

    public List<TreeNode> indexData(String kqbh, String type) {
        List<TreeNode> list =null;
        if("0".equals(type)){//仓房
            list = dxpPointMapper.selectListCfxx(kqbh);
        }else if("1".equals(type)){
            list = dxpPointMapper.selectListSbxx(kqbh);
        }
        return list;
    }

	public DXPCFXXVO selectDetail(String cfbh) {
		return dxpPointMapper.selectDetail(cfbh);
	}
    
}
