package com.jusfoun.ydylsz.service;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import com.jusfoun.ydylsz.mapper.KshHlhtSbxxMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.jusfoun.ydylsz.mapper.KshHlhtNktMapper;
import com.jusfoun.ydylsz.pojo.KshHlhtKuquInfo;
import com.jusfoun.ydylsz.pojo.KshHlhtXzqh;
import com.jusfoun.ydylsz.tool.PathTool;
import com.jusfoun.ydylsz.vo.in.KshHlhtSbxxInputVo;
import com.jusfoun.ydylsz.vo.out.base.RootResult;

@Service("kshHlhtNktService")
public class KshHlhtNktService {
	
	@Autowired
	private KshHlhtNktMapper kshHlhtNktMapper;

	@Autowired
	private KshHlhtSbxxMapper kshHlhtSbxxMapper;

	public Long queryTotalCount(KshHlhtSbxxInputVo vo) {		
		return kshHlhtNktMapper.queryTotalCount(vo);
	}

	public List<KshHlhtKuquInfo> queryList(KshHlhtSbxxInputVo vo,HttpServletRequest req) {
		
		List<KshHlhtKuquInfo> dataList = kshHlhtNktMapper.queryList(vo);
		
		/*for (KshHlhtKuquInfo kshHlhtKuquInfo : dataList) {
			
			KshHlhtXzqh xz = kshHlhtNktMapper.queryResource(kshHlhtKuquInfo.getResId());
			
			if(xz != null) {
				String url = xz.getStdcode();
				
				String path = PathTool.getFullHostUrl(req,null) + url;
				
				kshHlhtKuquInfo.setTpUrl(path);
				
				kshHlhtKuquInfo.setTpMc(xz.getStdname());

			}
		}*/
		
		return dataList;
	}

	public void checkKuquInfo(Integer id, String zt) {
		kshHlhtNktMapper.checkKuquInfo(id,zt);
	}

	public void updateKuquInfo(KshHlhtKuquInfo info) {
		info.setRefreshTime(new Date());
		String link = kshHlhtSbxxMapper.sleectImagePath(info.getResId());
		info.setTpUrl("/home/file/ftp/static/" +link);
		kshHlhtNktMapper.updateKuquInfo(info);
		// 更新设备信息中的库区代码
		kshHlhtNktMapper.updateSbxxByKqdm(info);
	}

	public KshHlhtKuquInfo viewTuPian(Integer id, HttpServletRequest request) {
		
		KshHlhtKuquInfo xzqh = kshHlhtNktMapper.viewTuPian(id);
		
		/*KshHlhtXzqh xz = kshHlhtNktMapper.queryResource(xzqh.getResId());
		
		if(xz != null) {
			String url = xz.getStdcode();
			
			String path = PathTool.getFullHostUrl(request,null) + url;
			
			xzqh.setTpUrl(path);
			
			xzqh.setTpMc(xz.getStdname());

		}*/
				
		return xzqh;
	}

	public List<KshHlhtKuquInfo> queryKqxxInfo(String kqmc) {
		return kshHlhtNktMapper.queryKqxxInfo(kqmc);
	}

	public String queryResIdByKqdm(String kqdm) {
		return  kshHlhtNktMapper.selectByKqdm(kqdm);
	}
}
