package com.jusfoun.ydylsz.service;

import java.io.File;
import java.io.IOException;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.net.*;

import java.security.MessageDigest;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.stream.Collectors;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.github.pagehelper.Page;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.hikvision.artemis.sdk.ArtemisHttpUtil;
import com.hikvision.artemis.sdk.config.ArtemisConfig;
import com.jusfoun.ydylsz.vo.*;
import com.jusfoun.ydylsz.vo.in.CameraStatisticsVO;
import org.apache.commons.lang.StringUtils;
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.CookieStore;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.conn.ssl.NoopHostnameVerifier;
import org.apache.http.cookie.Cookie;
import org.apache.http.entity.mime.HttpMultipartMode;
import org.apache.http.entity.mime.MultipartEntityBuilder;
import org.apache.http.impl.client.BasicCookieStore;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.ssl.SSLContextBuilder;
import org.apache.http.util.EntityUtils;

import org.apache.poi.hssf.usermodel.HSSFCellStyle;
import org.apache.poi.hssf.usermodel.HSSFFont;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.*;
import org.apache.poi.ss.util.CellRangeAddress;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.codehaus.jackson.map.ObjectMapper;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.BeansException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import com.jusfoun.ydylsz.mapper.KshHlhtNktMapper;
import com.jusfoun.ydylsz.mapper.KshHlhtSbxxMapper;
import com.jusfoun.ydylsz.mapper.KshHlhtXzqhMapper;
import com.jusfoun.ydylsz.mapper.KshHlhtZzsbglMapper;
import com.jusfoun.ydylsz.pojo.KshHlhtKuquInfo;
import com.jusfoun.ydylsz.pojo.KshHlhtSbxx;
import com.jusfoun.ydylsz.pojo.KshHlhtSheng;
import com.jusfoun.ydylsz.pojo.KshHlhtXzqh;
import com.jusfoun.ydylsz.pojo.KshHlhtZzsbgl;
import com.jusfoun.ydylsz.pojo.TreeNode;
import com.jusfoun.ydylsz.util.DDUtilPOI;
import com.jusfoun.ydylsz.vo.in.KshHlhtSbxxInVo;
import com.jusfoun.ydylsz.vo.in.KshHlhtSbxxInputVo;
import com.jusfoun.ydylsz.vo.out.base.RootResult;

import javax.annotation.Resource;
import javax.net.ssl.SSLContext;
import javax.servlet.http.HttpServletResponse;

@Service("kshHlhtSbxxService")
public class KshHlhtSbxxService {

    private Logger log = LoggerFactory.getLogger(this.getClass());

    @Autowired
    private KshHlhtSbxxMapper kshHlhtSbxxMapper;

    @Autowired
    private KshHlhtZzsbglMapper kshHlhtZzsbglMapper;

    @Autowired
    private KshHlhtXzqhMapper kshHlhtXzqhMapper;

    @Autowired
    private KshHlhtNktMapper kshHlhtNktMapper;

    @Autowired
    private CameraAreaService cameraAreaService;

    public Long queryTotalCount(KshHlhtSbxxInputVo vo) {
        return kshHlhtSbxxMapper.queryTotalCount(vo);
    }

    public List<KshHlhtSbxx> queryList(KshHlhtSbxxInputVo vo) {
        return kshHlhtSbxxMapper.queryList(vo);
    }

    public void insertKshHlhtSbxx(KshHlhtSbxx bean) {
        kshHlhtSbxxMapper.insertKshHlhtSbxx(bean);
    }

    public void updateKshHlhtSbxx(KshHlhtSbxx bean) {
        kshHlhtSbxxMapper.updateKshHlhtSbxx(bean);
    }

    public KshHlhtSbxx viewKshHlhtSbxx(Integer id) {
        return kshHlhtSbxxMapper.viewKshHlhtSbxx(id);
    }

    public List<KshHlhtZzsbgl> queryListBySbId(Integer zzjgId) {
        return kshHlhtZzsbglMapper.queryListBySbId(zzjgId);
    }

    public RootResult<KshHlhtSbxx> impSbxxInfo(MultipartFile file, KshHlhtSbxxInVo vo) throws IOException {
        RootResult<KshHlhtSbxx> r = new RootResult<KshHlhtSbxx>();
        Integer[] arr = new Integer[]{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12};
        List<Map<String, String>> dataList = DDUtilPOI.readXlsFileInputStream(file, arr);
        String errInfo = "";
        for (int i = 0; i < dataList.size(); i++) {
            if (i == 0) {
                continue;
            } else {
                Map<String, String> map = dataList.get(i);
                KshHlhtSbxx info = new KshHlhtSbxx();
                String sbId = map.get(1);
                System.out.println("设备Id -----" + sbId);
                if (sbId != null) {
                    info.setSbId(map.get("1") == null ? map.get(1) : map.get("1"));
                    info.setJkdmc(map.get("2") == null ? map.get(2) : map.get("2"));
                    info.setZzjgMc(map.get("3") == null ? map.get(3) : map.get("3"));
                    info.setTyxydm(map.get("4") == null ? map.get(4) : map.get("4"));
                    info.setKqbm(map.get("5") == null ? map.get(5) : map.get("5"));
                    info.setKqmc(map.get("6") == null ? map.get(6) : map.get("6"));
                    info.setKqdz(map.get("7") == null ? map.get(7) : map.get("7"));
                    String kqlx = map.get(8);
                    Integer kqlx1 = Integer.parseInt(kqlx);
                    info.setKqlx(kqlx1);
                    info.setSbnkt(map.get("9") == null ? map.get(9) : map.get("9"));
                    info.setAzwwlx(map.get("10") == null ? map.get(10) : map.get("10"));
                    info.setSbgnlx(map.get("11") == null ? map.get(11) : map.get("11"));
                    info.setJsqysm(map.get("12") == null ? map.get(12) : map.get("12"));
                    kshHlhtSbxxMapper.updateKshHlhtSbxxBySbId(info);

//					KshHlhtSbxx sbxx = kshHlhtSbxxMapper.queryBySbId(sbId);
//
//					if(sbxx != null) {
//
//						String strname = null;
//
//						if(info.getKqmc().contains("（")) {
//
//							strname = info.getKqmc().substring(info.getKqmc().indexOf("（") +1, info.getKqmc().indexOf("）"));
//
//						}else {
//
//							strname = info.getKqmc();
//
//						}
//
//						Integer zzjgId = kshHlhtSbxxMapper.queryByZzjgMc(strname);
//
//						Integer zzsbId =  kshHlhtSbxxMapper.queryByZzSbgl(sbxx.getId(),zzjgId);
//
//						    if(null == zzsbId) {
//
//						    	KshHlhtZzsbgl zzsb = new KshHlhtZzsbgl();
//
//								zzsb.setSbId(sbxx.getId());
//
//								zzsb.setZzjgId(zzjgId);
//
//								kshHlhtZzsbglMapper.insertZzsbgl(zzsb);
//						    }
//
//						}

                }
            }
        }
        return r;
    }

    public List<KshHlhtXzqh> querySheng(String stdcode) {
        if (stdcode != null) {
            String code = stdcode + "0000";
            return kshHlhtXzqhMapper.querySheng(code);
        } else {
            return kshHlhtXzqhMapper.queryAllSheng();
        }
    }

    public List<KshHlhtXzqh> queryShi(String stdcode) {
        String subCode = stdcode.substring(0, 2);
        String code1 = subCode + "%" + "00";
        String code2 = subCode + "0000";
        return kshHlhtXzqhMapper.queryShi(code1, code2);
    }

    public List<KshHlhtXzqh> queryXian(String stdcode) {
        String subCode = stdcode.substring(0, 4);
        String code1 = subCode + "%";
        String code2 = subCode + "00";
        return kshHlhtXzqhMapper.queryXian(code1, code2);
    }

    public List<KshHlhtZzsbgl> queryListByZdySbId(Integer zzjgId) {
        return kshHlhtZzsbglMapper.queryListByZdySbId(zzjgId);
    }

    public KshHlhtSbxx queryBySbId(String gbIndexCode) {
        return kshHlhtSbxxMapper.queryBySbId(gbIndexCode);
    }

    public void saveKuquInfo(KshHlhtKuquInfo info) {
        info.setRefreshTime(new Date());
        String link = kshHlhtSbxxMapper.sleectImagePath(info.getResId());
        info.setTpUrl("/home/file/ftp/static/" + link);
        kshHlhtSbxxMapper.saveKuquInfo(info);
        // 更新设备信息中的库区代码
        kshHlhtNktMapper.updateSbxxByKqdm(info);
    }

    public List<KshHlhtSbxx> querySbxxList(Integer pageNum, Integer pageSize, List list, List list2) {
        return kshHlhtSbxxMapper.querySbxxList(pageNum, pageSize, list, list2);
    }

    public RootResult<Object> sbxxExportExcel(KshHlhtSbxxInputVo vo) {

        RootResult<Object> r = new RootResult<Object>();

        Map<String, Object> map1 = new HashMap<String, Object>();

        List<KshHlhtSbxx> data = kshHlhtSbxxMapper.sbxxExportExcel(vo);

        map1.put("data", data);

        r.setData(map1);

        return r;
    }

    public String queryByClassId(Integer zzjgId) {
        return kshHlhtSbxxMapper.queryByClassId(zzjgId);
    }

    public List<KshHlhtZzsbgl> queryByZzId(String classStrId) {
        return kshHlhtSbxxMapper.queryByZzId(classStrId);
    }

    public List<KshHlhtXzqh> queryKqbm(String kqbm) {
        return kshHlhtSbxxMapper.queryKqbm(kqbm);
    }

    public List<KshHlhtXzqh> queryByKqmc() {
        return kshHlhtSbxxMapper.queryByKqmc();
    }

    public Integer queryCount(List list1) {
        return kshHlhtSbxxMapper.queryCount(list1);
    }

    public List<String> queryListStrSbId(String zzjgId) {
        return kshHlhtSbxxMapper.queryListStrSbId(zzjgId);
    }

    public void deleteListStrBySbId(List newSbInfoId) {
        kshHlhtSbxxMapper.deleteListStrBySbId(newSbInfoId);
    }

    public PageInfo<CameraMalfunctionDO> selectCameraMalfunctionList(Integer pageNo, Integer pageSize, String kqmc, String bjsj, String kqdm, String sbzt) {
        PageHelper.startPage(pageNo, pageSize);
        Map<String, Object> params = new HashMap<String, Object>();
        if (StringUtils.isNotBlank(kqmc)) {
            params.put("kqmc", kqmc);
        }
        if (StringUtils.isNotBlank(bjsj)) {
            // 报警时间转换成yyyy-MM-dd HH:mm:ss的日期格式，一个开始，一个截止，
            // 比如2023-11-07，变成bjsjks:2023-11-07 00:00:00，bjsjjz:2023-11-07 23:59:59 并存到param
            try {
                SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
                Date date = sdf.parse(bjsj);
                Calendar calendar = Calendar.getInstance();
                calendar.setTime(date);
                calendar.set(Calendar.HOUR_OF_DAY, 0);
                calendar.set(Calendar.SECOND, 0);
                calendar.set(Calendar.MINUTE, 0);
                Date bjsjks = calendar.getTime();
                calendar.set(Calendar.HOUR_OF_DAY, 23);
                calendar.set(Calendar.SECOND, 59);
                calendar.set(Calendar.MINUTE, 59);
                Date bjsjjz = calendar.getTime();
                params.put("bjsjks", bjsjks);
                params.put("bjsjjz", bjsjjz);
            } catch (ParseException e) {
                e.getMessage();
            }
        }
        if (StringUtils.isNotBlank(kqdm)) {
            params.put("kqdm", kqdm);
        }
        Page<CameraMalfunctionDO> listPage = kshHlhtSbxxMapper.selectCameraMalfunctionList(params);
        return new PageInfo<CameraMalfunctionDO>(listPage);
    }

    public PageInfo<CameraMalfunctionDTO> selectCameraMalfunctionDetailList(Integer pageNo, Integer pageSize, String kqmc, String bjsj, String kqdm, String sbzt) {
        PageHelper.startPage(pageNo, pageSize);
        Map<String, Object> params = new HashMap<String, Object>();
        if (StringUtils.isNotBlank(kqmc)) {
            params.put("kqmc", kqmc);
        }
        if (StringUtils.isNotBlank(bjsj)) {
            // 报警时间转换成yyyy-MM-dd HH:mm:ss的日期格式，一个开始，一个截止，
            // 比如2023-11-07，变成bjsjks:2023-11-07 00:00:00，bjsjjz:2023-11-07 23:59:59 并存到param
            try {
                SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
                Date date = sdf.parse(bjsj);
                Calendar calendar = Calendar.getInstance();
                calendar.setTime(date);
                calendar.set(Calendar.HOUR_OF_DAY, 0);
                calendar.set(Calendar.SECOND, 0);
                calendar.set(Calendar.MINUTE, 0);
                Date bjsjks = calendar.getTime();
                calendar.set(Calendar.HOUR_OF_DAY, 23);
                calendar.set(Calendar.SECOND, 59);
                calendar.set(Calendar.MINUTE, 59);
                Date bjsjjz = calendar.getTime();
                params.put("bjsjks", bjsjks);
                params.put("bjsjjz", bjsjjz);
            } catch (ParseException e) {
                e.getMessage();
            }
        }
        if (StringUtils.isNotBlank(kqdm)) {
            params.put("kqdm", kqdm);
        }
        if (StringUtils.isNotBlank(sbzt)) {
            params.put("sbzt", sbzt);
        }
        Page<CameraMalfunctionDTO> listPage = kshHlhtSbxxMapper.selectCameraMalfunctionDetailList(params);
        return new PageInfo<CameraMalfunctionDTO>(listPage);
    }

    public static String generateKey(OpsOffLineCameraVO vo) {
        return vo.getStdname() + "-" + vo.getStdcode();
    }


    @Scheduled(cron = "0 0 23 * * ?")
    public void selectCameraMalfunctionListTest() {
        try {
            String result = GetCameraPreviewStatusURL(1, 1000, null, "0", null);
            List<KshHlhtSbxx> resultData = new ArrayList<>();
            List<CameraMalfunctionVO> list = new ArrayList<>();
            if (result != null) {
                JSONObject jsonString = JSONObject.parseObject(result);
                JSONObject jsonData = jsonString.getJSONObject("data");
                JSONArray arrayList = JSON.parseArray(jsonData.getString("list"));
                Iterator<Object> it = arrayList.iterator();
                while (it.hasNext()) {
                    KshHlhtSbxx kshHlhtSbxx = new KshHlhtSbxx();
                    JSONObject obj = (JSONObject) it.next();
                    String indexCode = obj.getString("indexCode");
                    KshHlhtSbxxInputVo vo = new KshHlhtSbxxInputVo();
                    if (StringUtils.isNotBlank(indexCode)) {
                        vo.setPageSize(null);
                        vo.setPageNum(null);
                        vo.setJkdbm(indexCode);
                        List<KshHlhtSbxx> data = this.queryList(vo);
                        if (null != data && data.size() > 0) {
                            BeanUtils.copyProperties(data.get(0), kshHlhtSbxx);
                            resultData.add(kshHlhtSbxx);
                        }

                    }
                    String online = obj.getString("online");
                    if (StringUtils.isNotBlank(online)) {
                        kshHlhtSbxx.setSfzx(Integer.parseInt(online));
                    }
                }
                // resultData信息当中的内容保存到list当中
                if (resultData != null && resultData.size() > 0) {
                    for (KshHlhtSbxx kshHlhtSbxx : resultData) {
                        CameraMalfunctionVO cameraMalfunctionVO = new CameraMalfunctionVO();
                        cameraMalfunctionVO.setId(UUID.randomUUID().toString().replace("-", ""));
                        cameraMalfunctionVO.setKqbm(kshHlhtSbxx.getKqbm());
                        cameraMalfunctionVO.setKqmc(kshHlhtSbxx.getKqmc());
                        cameraMalfunctionVO.setJkdbm(kshHlhtSbxx.getJkdbm());
                        cameraMalfunctionVO.setJkdmc(kshHlhtSbxx.getJkdmc());
                        cameraMalfunctionVO.setGzlx("摄像头离线");
                        cameraMalfunctionVO.setBjsj(new Date());
                        cameraMalfunctionVO.setCreate_time(new Date());
                        cameraMalfunctionVO.setUpdate_time(new Date());
                        // 设置库区代码
                        if (StringUtils.isNotBlank(cameraMalfunctionVO.getKqbm())) {
                            String kqdm = kshHlhtSbxxMapper.getKqdmForCameraMalfunctionByKqbm(cameraMalfunctionVO.getKqbm());
                            cameraMalfunctionVO.setKqdm(kqdm);
                        }
                        Map<String, String> stringStringMap = new HashMap<>();
                        stringStringMap.put("stdname", cameraMalfunctionVO.getJkdmc());
                        stringStringMap.put("stdcode", cameraMalfunctionVO.getJkdbm());
                        List<OpsOffLineCameraVO> list1 = new ArrayList<>();

                        List<OpsOffLineCameraVO> opsOffLineCameraVOS = kshHlhtSbxxMapper.selectCameras(stringStringMap);
                        if (opsOffLineCameraVOS != null && opsOffLineCameraVOS.size() > 0) {
                            list1.addAll(opsOffLineCameraVOS);
                        }

                        // 将list1根据stdname，stdcode分组
                        Map<String, List<OpsOffLineCameraVO>> map = list1.stream().collect(Collectors.groupingBy(vo -> generateKey(vo)));
                        if (list1.size() > 0) {
                            List<Long> collect = list1.stream().map(item -> item.getMainId()).collect(Collectors.toList());
                            List<OpsOffLineDO> opsOffLineDOS = kshHlhtSbxxMapper.selectByFids(collect);
                            List<OpsOffLineVO> list2 = new ArrayList<>();
                            if (opsOffLineDOS != null && opsOffLineDOS.size() > 0) {
                                for (OpsOffLineDO opsOffLineDO : opsOffLineDOS) {
                                    OpsOffLineVO opsOffLineVO = new OpsOffLineVO();
                                    BeanUtils.copyProperties(opsOffLineDO, opsOffLineVO);
                                    OpsOffLineCameraVO queryCamera = new OpsOffLineCameraVO();
                                    queryCamera.setMainId(opsOffLineDO.getFid());
                                    List<OpsOffLineCameraVO> offLineCameraList = kshHlhtSbxxMapper.selectByMainId(queryCamera);
                                    opsOffLineVO.setCameraList(offLineCameraList);
                                    list2.add(opsOffLineVO);
                                }
                                // 根据verify_seal_date降序排序
                                list2.sort(Comparator.comparing(OpsOffLineVO::getVerifySealDate).reversed());
                            }
                            List<WorkOrderVO> list3 = kshHlhtSbxxMapper.selectByOpsOffLineFid(collect);
                            if (list3 != null && list3.size() > 0) {
                                for (WorkOrderVO workOrderVO : list3) {
                                    WorkOrderVO sub = kshHlhtSbxxMapper.countSubTabByFid(workOrderVO.getFid());
                                    if (sub != null) {
                                        workOrderVO.setProblemCount(sub.getProblemCount());
                                        workOrderVO.setSolveCount(sub.getSolveCount());
                                    }
                                    Long opsOffLineFid = workOrderVO.getOpsOffLineFid();
                                    OpsOffLineCameraVO queryCamera = new OpsOffLineCameraVO();
                                    queryCamera.setMainId(opsOffLineFid);
                                    List<OpsOffLineCameraVO> offLineCameraList = kshHlhtSbxxMapper.selectByMainId(queryCamera);
                                    workOrderVO.setCameraList(offLineCameraList);
                                }
                                // 根据sqrq降序排序
                                list3.sort((o1, o2) -> {
                                    if (o1.getVerifySealDate() == null || o2.getVerifySealDate() == null) {
                                        return 0;
                                    }
                                    return o2.getVerifySealDate().compareTo(o1.getVerifySealDate());
                                });
                            }
                            if (list2.size() > 0) {

                                String key = cameraMalfunctionVO.getJkdmc() + "-" + cameraMalfunctionVO.getJkdbm();
                                List<OpsOffLineCameraVO> opsOffLineCameraVOS1 = map.get(key);
                                // 根据筛选出来的摄像头取出mainid，并筛选出mainid和OpsOffLineVO的fid相同的集合,并按照verifySealDate倒叙排序
                                if (opsOffLineCameraVOS1 != null && opsOffLineCameraVOS1.size() > 0) {
                                    List<Long> collect1 = opsOffLineCameraVOS1.stream().map(item -> item.getMainId()).collect(Collectors.toList());
                                    List<OpsOffLineVO> collect2 = list2.stream().filter(item -> collect1.contains(item.getFid()))
                                            .sorted(Comparator.comparing(OpsOffLineVO::getVerifySealDate).reversed()).collect(Collectors.toList());
                                    if (collect2 != null && collect2.size() > 0) {
                                        OpsOffLineVO opsOffLineVO = collect2.get(0);
                                        cameraMalfunctionVO.setLxtzdid(opsOffLineVO.getFid());
                                    }
                                }

                            }
                            if (list3.size() > 0) {
                                String key = cameraMalfunctionVO.getJkdmc() + "-" + cameraMalfunctionVO.getJkdbm();
                                List<OpsOffLineCameraVO> opsOffLineCameraVOS1 = map.get(key);
                                // 根据筛选出来的摄像头取出mainid，并筛选出mainid和OpsOffLineVO的fid相同的集合,并按照verifySealDate倒叙排序
                                if (opsOffLineCameraVOS1 != null && opsOffLineCameraVOS1.size() > 0) {
                                    List<Long> collect1 = opsOffLineCameraVOS1.stream().map(item -> item.getMainId()).collect(Collectors.toList());
                                    List<WorkOrderVO> collect2 = list3.stream().filter(item -> collect1.contains(item.getOpsOffLineFid()))
                                            .sorted((o1, o2) -> {
                                                if (o1.getVerifySealDate() == null || o2.getVerifySealDate() == null) {
                                                    return 0;
                                                }
                                                return o2.getVerifySealDate().compareTo(o1.getVerifySealDate());
                                            }).collect(Collectors.toList());
                                    if (collect2 != null && collect2.size() > 0) {
                                        WorkOrderVO workOrderVO = collect2.get(0);
                                        cameraMalfunctionVO.setYwxxgdid(workOrderVO.getFid());
                                    }
                                }
                            }
                        }
                        // 保存数据库
                        kshHlhtSbxxMapper.insertCameraMalfunction(cameraMalfunctionVO);
                        list.add(cameraMalfunctionVO);
                    }
                }

            }
            System.out.println(list);
            log.info("摄像头故障报警表插入定时任务数据：数据定时查询");
        } catch (Exception e) {
            log.info("摄像头故障报警表插入定时任务数据：数据定时查询 {}" + e.getMessage());
        }
    }

    public static String GetCameraPreviewStatusURL(Integer pageNo, Integer pageSize, String indexCodes, String status, String regionId) {

        /**
         * STEP1：设置平台参数，根据实际情况,设置host appkey appsecret 三个参数.
         */
        // 外网的
		/*ArtemisConfig.host = "106.3.145.75:443"; // artemis网关服务器ip端口
		ArtemisConfig.appKey = "26469219"; // 秘钥appkey
		ArtemisConfig.appSecret = "w4GKdMLvVTxDLUgtzV2L";*/// 秘钥appSecret

        // 内网的
		/*ArtemisConfig.host = "172.16.13.3:443"; // artemis网关服务器ip端口
		ArtemisConfig.appKey = "26469219"; // 秘钥appkey    28116466
		ArtemisConfig.appSecret = "w4GKdMLvVTxDLUgtzV2L";// 秘钥appSecret   W9zihM0hNRsnNic3zuKM
*/
        ArtemisConfig.host = "10.69.3.1:443"; // artemis网关服务器ip端口
        ArtemisConfig.appKey = "24012924"; // 秘钥appkey   28116466
        ArtemisConfig.appSecret = "uHzSYRUJpnCVCJSIEUWc";// 秘钥appSecret   W9zihM0hNRsnNic3zuKM

        /**
         * STEP2：设置OpenAPI接口的上下文
         */
        final String ARTEMIS_PATH = "/artemis";

        String body = null;

        String contentType = null;

        Map path = new HashMap();

        /**
         * STEP3：设置接口的URI地址
         */
        final String previewURLsApi = ARTEMIS_PATH +
                "/api/nms/v1/online/camera/get";     // 获取分页监控点资源
        path = new HashMap(2) {
            {
                put("https://", previewURLsApi);//根据现场环境部署确认是http还是https
            }
        };

        /**
         * STEP4：设置参数提交方式
         */
        contentType = "application/json";

        /**
         * STEP5：组装请求参数
         */
        JSONObject jsonBody = new JSONObject();

        // 获取分页监控点资源参数

        jsonBody.put("pageNo", pageNo);
        jsonBody.put("pageSize", pageSize);
        if (StringUtils.isNotBlank(indexCodes)) {
            jsonBody.put("indexCodes", "[" + indexCodes + "]");
        }
        if (StringUtils.isNotBlank(status)) {
            jsonBody.put("status", "" + status + "");
        }
        if (StringUtils.isNotBlank(regionId)) {
            jsonBody.put("regionId", "" + regionId + "");
        }
        body = jsonBody.toJSONString().replace("\"[", "[\"").replace("]\"", "\"]");

        /**
         * STEP6：调用接口
         */
        String result = ArtemisHttpUtil.doPostStringArtemis(path, body, null, null, contentType, null);// post请求application/json类型参数
        return result;
    }

    public JSONArray getCameraPreviewStatusURLMenu(String pId, String cookie) {
        try {
//            String cookie = getCookie();
            // 忽略证书验证
            SSLContext sslContext = new SSLContextBuilder().loadTrustMaterial(null, (chain, authType) -> true).build();
            CookieStore cookieStore = new BasicCookieStore();
            HttpClient httpClient = HttpClients.custom()
                    .setSslcontext(sslContext)
                    .setDefaultCookieStore(cookieStore)
                    .setSSLHostnameVerifier(NoopHostnameVerifier.INSTANCE)
                    .build();

            String url = "https://10.69.3.1/nms/ui/v1/resOrgService/orgtree";
            Map<String, String> map = new HashMap<String, String>();
            map.put("pId", pId);
            String result = addUri(cookie, url, map);
            if (result != null) {
                JSONObject jsonString = JSONObject.parseObject(result);
                if (jsonString != null && jsonString.getString("data") != null) {
                    JSONArray data = (JSONArray) jsonString.get("data");
                    return data;
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

    public static String addUri(HttpClient client, String url, Map<String, String> map) throws Exception {

        try {
            // 先调用https://10.69.3.1/portal/login/ajax/postLoginData.do，返回的请求头中获取Cookie并赋值给JSESSIONID
            String loginUrl = "https://10.69.3.1/portal/login/ajax/postLoginData.do";
            Map<String, String> loginParam = new HashMap<String, String>();
            loginParam.put("userName", "admin");
            loginParam.put("password", "A1b2c3d4e5");

            // 发送post请求
            HttpPost firstHttpPost = new HttpPost(loginUrl);

            // 使用MultipartEntityBuilder构建multipart/form-data实体
            MultipartEntityBuilder firstBuilder = MultipartEntityBuilder.create();
            firstBuilder.setMode(HttpMultipartMode.BROWSER_COMPATIBLE);
            for (Map.Entry<String, String> entry : loginParam.entrySet()) {
                firstBuilder.addTextBody(entry.getKey(), entry.getValue());
            }
            // builder.addBinaryBody("file", new File("example.jpg")); // 添加文件参数（如果需要的话）

            HttpEntity entity = firstBuilder.build();
            firstHttpPost.setEntity(entity);

            HttpResponse firstResponse = client.execute(firstHttpPost);
            String responseBody = EntityUtils.toString(firstResponse.getEntity());
            if (firstResponse.getStatusLine().getStatusCode() == 200) {
                JSONObject jsonString = JSONObject.parseObject(responseBody);
                if (jsonString != null && jsonString.getString("data") != null) {
                    JSONObject data = (JSONObject) jsonString.get("data");
                    String pwd = loginParam.get("password");
                    String vcode = data.getString("vCode");
                    String salt = data.getString("salt");
                    String codeId = data.getString("codeId");
                    // encryptPswd = SHA256(SHA256（pwd+salt）+vcode)
                    String p1 = pwd + salt;
                    MessageDigest digest = MessageDigest.getInstance("SHA-256");
                    byte[] hash = digest.digest(p1.getBytes("UTF-8"));
                    String p2 = bytesToHex(hash);
                    String p3 = p2 + vcode;
                    byte[] hash2 = digest.digest(p3.getBytes("UTF-8"));
                    String p4 = bytesToHex(hash2);
                    String submitUrl = "https://10.69.3.1/portal/login/ajax/submit.do";
                    Map<String, String> submitParam = new HashMap<String, String>();
                    submitParam.put("codeId", codeId);
                    submitParam.put("password", p4);
                    submitParam.put("serviceUrl", "https://10.69.3.1/portal/cas/loginPage?service=https://10.69.3.1:443/portal");
                    submitParam.put("userName", "admin");
                    submitParam.put("userType", "0");
                    submitParam.put("lang", "zh_CN");
                    // 发送post请求
                    HttpPost secondPost = new HttpPost(submitUrl);
                    // 使用MultipartEntityBuilder构建multipart/form-data实体
                    MultipartEntityBuilder secondBuilder = MultipartEntityBuilder.create();
                    secondBuilder.setMode(HttpMultipartMode.BROWSER_COMPATIBLE);
                    for (Map.Entry<String, String> entry : submitParam.entrySet()) {
                        secondBuilder.addTextBody(entry.getKey(), entry.getValue());
                    }
                    // builder.addBinaryBody("file", new File("example.jpg")); // 添加文件参数（如果需要的话）

                    HttpEntity secondEntity = secondBuilder.build();
                    secondPost.setEntity(secondEntity);
                    HttpResponse secondResponse = client.execute(secondPost);
                    String secondResponseBody = EntityUtils.toString(secondResponse.getEntity());
                    if (secondResponse.getStatusLine().getStatusCode() == 200) {
                        JSONObject subJson = JSONObject.parseObject(secondResponseBody);
                        if (subJson != null && subJson.getString("data") != null) {
                            String subUrlResult = subJson.getString("data");
                            // subData 为”https://10.69.3.1:443/bic/ssoService/v1/tokenLogin
                            // ?token=ST-167237-JGOI3kCollSeZVMZbdvl-cas
                            // &service=https://10.69.3.1:443/portal/login
                            // ?redirect=aHR0cHM6Ly8xMC42OS4zLjE6NDQzL3BvcnRhbA==“格式
                            // 发送get请求
                            String token = subUrlResult.substring(subUrlResult.indexOf("token=") + 6, subUrlResult.indexOf("&service"));
                            HttpGet httpGet = new HttpGet(subUrlResult);
                            HttpResponse thirdResponse = client.execute(httpGet);
                            String thirdResponseBody = EntityUtils.toString(thirdResponse.getEntity());
                            if (thirdResponse.getStatusLine().getStatusCode() == 200) {
                                HttpGet httpGet1 = new HttpGet("https://10.69.3.1/nms/views/reports");
                                HttpResponse response1 = client.execute(httpGet1);
                                if (response1.getStatusLine().getStatusCode() == 200) {
                                    HttpGet secondGet = new HttpGet("https://10.69.3.1/portal/cas/login?service=https://10.69.3.1/nms/views/reports");
                                    HttpResponse execute = client.execute(secondGet);
                                    String s = EntityUtils.toString(execute.getEntity());
                                    if (execute.getStatusLine().getStatusCode() == 200) {
                                        HttpGet thirdGet = new HttpGet("https://10.69.3.1/bic/ssoService/v1/casLogin?service=https://10.69.3.1/nms/views/reports&login=https://10.69.3.1:443/portal/cas/loginPage&home=https://10.69.3.1:443/portal");
                                        HttpResponse thirdResponse1 = client.execute(thirdGet);
                                        if (thirdResponse1.getStatusLine().getStatusCode() == 200) {
                                            HttpGet fourthGet = new HttpGet("https://10.69.3.1/nms/views/reports?ticket=" + token);
                                            HttpResponse fourthResponse = client.execute(fourthGet);
                                            if (fourthResponse.getStatusLine().getStatusCode() == 200) {
                                                HttpPost thirdPost = new HttpPost(url);
                                                // 使用MultipartEntityBuilder构建multipart/form-data实体
                                                MultipartEntityBuilder thirdBuilder = MultipartEntityBuilder.create();
                                                thirdBuilder.setMode(HttpMultipartMode.BROWSER_COMPATIBLE);
                                                for (Map.Entry<String, String> entry : map.entrySet()) {
                                                    thirdBuilder.addTextBody(entry.getKey(), entry.getValue());
                                                }
                                                // builder.addBinaryBody("file", new File("example.jpg")); // 添加文件参数（如果需要的话）

                                                HttpEntity thirdEntity = thirdBuilder.build();
                                                thirdPost.setEntity(thirdEntity);

                                                HttpResponse fourResponse = client.execute(thirdPost);
                                                String fourResponseBody = EntityUtils.toString(thirdResponse.getEntity());
                                                if (fourResponse.getStatusLine().getStatusCode() == 200) {
                                                    return fourResponseBody;
                                                } else {
                                                    System.out.println("Response Code: " + thirdResponse.getStatusLine().getStatusCode());
                                                    return fourResponseBody;
                                                }
                                            } else {
                                                System.out.println("Response Code: " + fourthResponse.getStatusLine().getStatusCode());
                                                return null;
                                            }
                                        } else {
                                            System.out.println("Response Code: " + thirdResponse1.getStatusLine().getStatusCode());
                                            return null;
                                        }
                                    } else {
                                        System.out.println("Response Code: " + execute.getStatusLine().getStatusCode());
                                        return null;
                                    }
                                } else {
                                    System.out.println("Response Code: " + response1.getStatusLine().getStatusCode());
                                    return null;
                                }

                            } else {
                                System.out.println("Response Code: " + thirdResponse.getStatusLine().getStatusCode());
                                return null;
                            }
                        }

                    } else {
                        System.out.println("Response Code: " + secondResponse.getStatusLine().getStatusCode());
                        return null;
                    }
                }
            } else {
                System.out.println("Response Code: " + firstResponse.getStatusLine().getStatusCode());
                return null;
            }


        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

    public static String addUri(String cookie, String url, Map<String, String> map) throws Exception {

        try {
            // 忽略证书验证
            SSLContext sslContext = new SSLContextBuilder().loadTrustMaterial(null, (chain, authType) -> true).build();

            HttpClient httpClient = HttpClients.custom()
                    .setSslcontext(sslContext)
                    .setSSLHostnameVerifier(NoopHostnameVerifier.INSTANCE)
                    .build();

            HttpPost httpPost = new HttpPost(url);
            httpPost.setHeader("Cookie", cookie);

            // 使用MultipartEntityBuilder构建multipart/form-data实体
            MultipartEntityBuilder builder = MultipartEntityBuilder.create();
            builder.setMode(HttpMultipartMode.BROWSER_COMPATIBLE);
            for (Map.Entry<String, String> entry : map.entrySet()) {
                builder.addTextBody(entry.getKey(), entry.getValue());
            }
            // builder.addBinaryBody("file", new File("example.jpg")); // 添加文件参数（如果需要的话）

            HttpEntity entity = builder.build();
            httpPost.setEntity(entity);

            HttpResponse response = httpClient.execute(httpPost);
            String responseBody = EntityUtils.toString(response.getEntity());
            if (response.getStatusLine().getStatusCode() == 200) {
                return responseBody;
            } else {
                System.out.println("Response Code: " + response.getStatusLine().getStatusCode());
                return responseBody;
            }

        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

    public static JSONObject addUri(String url, Map<String, String> map) throws Exception {

        try {
            // 忽略证书验证
            SSLContext sslContext = new SSLContextBuilder().loadTrustMaterial(null, (chain, authType) -> true).build();

            HttpClient httpClient = HttpClients.custom()
                    .setSslcontext(sslContext)
                    .setSSLHostnameVerifier(NoopHostnameVerifier.INSTANCE)
                    .build();

            HttpPost httpPost = new HttpPost(url);

            // 使用MultipartEntityBuilder构建multipart/form-data实体
            MultipartEntityBuilder builder = MultipartEntityBuilder.create();
            builder.setMode(HttpMultipartMode.BROWSER_COMPATIBLE);
            for (Map.Entry<String, String> entry : map.entrySet()) {
                builder.addTextBody(entry.getKey(), entry.getValue());
            }
            // builder.addBinaryBody("file", new File("example.jpg")); // 添加文件参数（如果需要的话）

            HttpEntity entity = builder.build();
            httpPost.setEntity(entity);

            HttpResponse response = httpClient.execute(httpPost);
            // 获取header
            org.apache.http.Header[] allHeaders = response.getAllHeaders();
            String cookie = "";
            for (org.apache.http.Header header : allHeaders) {
                if (header.getName().equals("Set-Cookie")) {
                    cookie = header.getValue().substring(0, header.getValue().indexOf(";"));
                }
            }
            String responseBody = EntityUtils.toString(response.getEntity());
            if (response.getStatusLine().getStatusCode() == 200) {
                JSONObject jsonObject = new JSONObject();
                jsonObject.put("cookie", cookie);
                jsonObject.put("responseBody", responseBody);
                return jsonObject;
            } else {
                System.out.println("Response Code: " + response.getStatusLine().getStatusCode());
                return null;
            }

        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

    public PageInfo<CameraStatisticsVO> queryCameraPreviewStatus(Integer pageNo, Integer pageSize, CameraStatisticsVO vo) {
        List<CameraStatisticsVO> list = getCameraStatisticsVOS(vo);
        // 手动分页
        int start = (pageNo - 1) * pageSize;
        int end = pageNo * pageSize;
        if (end > list.size()) {
            end = list.size();
        }
        List<CameraStatisticsVO> sub = list.subList(start, end);
        PageInfo<CameraStatisticsVO> pageInfo = new PageInfo<CameraStatisticsVO>();
        pageInfo.setSize(pageSize);
        pageInfo.setList(sub);
        pageInfo.setPageNum(pageNo);
        pageInfo.setTotal(list.size());
        pageInfo.setPageSize(pageSize);
        pageInfo.setStartRow(start);
        pageInfo.setEndRow(end);
        pageInfo.setPages((int) Math.ceil((double) list.size() / pageSize));
        return pageInfo;
    }

    private List<CameraStatisticsVO> getCameraStatisticsVOS(CameraStatisticsVO vo) {
//        // 根据区域名称，区域节点名称，orgname来判断不同的查询等级以及结果
//        if (StringUtils.isNotBlank(vo.getQymc())) {
//            // 如果区域名称不为空并且区域节点名称不为空，查询等级为3
//            if (StringUtils.isBlank(vo.getQyjdmc())) {
//                vo.setLevel(2);
//            } else {
//                // 如果区域节点名称不为空并且orgname为空，查询等级为3
//                if (StringUtils.isBlank(vo.getOrgname())) {
//                    vo.setLevel(3);
//                } else {
//                    // 如果orgname不为空，查询等级为4
//                    String[] split = vo.getOrgname().split(",");
//                    vo.setOrgnameList(Arrays.asList(split));
//                    vo.setLevel(4);
//                }
//            }
//        } else {
//            // 如果区域名称为空,查询等级为1
//            vo.setLevel(1);
//        }

//        switch (vo.getLevel()) {
//            case 1:
//                list = kshHlhtSbxxMapper.queryCameraPreviewStatusForSj(vo);
//                break;
//            case 2:
//                list = kshHlhtSbxxMapper.queryCameraPreviewStatusForQy(vo);
//                break;
//            case 3:
//                list = kshHlhtSbxxMapper.queryCameraPreviewStatusForKd(vo);
//                break;
//            case 4:
//                list = kshHlhtSbxxMapper.queryCameraPreviewStatusForFl(vo);
//                break;
//        }
        String orgCode = vo.getOrgCode();


        // 如果orgCode为LS001 LS001021 LS001019 LS001020,level设置成1
        if (StringUtils.isNotBlank(orgCode) && (orgCode.equals("LS001") || orgCode.equals("LS001021") || orgCode.equals("LS001019") || orgCode.equals("LS001020"))) {
            vo.setLevel(1);
        }
        // 如果orgCode不为LS001 LS001021 LS001019 LS001020,并且levelType为1，level设置成2
        if (StringUtils.isNotBlank(orgCode) && !orgCode.equals("LS001") && !orgCode.equals("LS001021") && !orgCode.equals("LS001019") && !orgCode.equals("LS001020") && vo.getLevelType() == 1) {
            vo.setLevel(2);
        }
        // 如果orgCode不为LS001 LS001021 LS001019 LS001020,并且levelType为2，level设置成4
        if (StringUtils.isNotBlank(orgCode) && !orgCode.equals("LS001") && !orgCode.equals("LS001021") && !orgCode.equals("LS001019") && !orgCode.equals("LS001020") && vo.getLevelType() == 2) {
            vo.setLevel(4);
        }
        JSONObject cameraAreas = cameraAreaService.getCameraAreas(orgCode);
        if (cameraAreas == null) {
            return null;
        }
        // 写个方法获取cameraAreas中所有最底层的节点text值，返回成List<string>
        // 如果orgCode为LS001 LS001021 LS001019 LS001020，查所有
        Map<String, List<CameraStatisticsVO>> map = new HashMap<>();
        JSONObject root = JSONObject.parseObject(cameraAreas.getString("root"));
        JSONArray children = root.getJSONArray("children");
        if (vo.getLevel() == 4) {
            String qyjdmc = root.getString("text");
            vo.setQyjdmcList(Collections.singletonList(qyjdmc));
        }
        vo.setWjmc(root.getString("text"));
        List<CameraStatisticsVO> cameraStatisticsVOList = kshHlhtSbxxMapper.queryCamerasPreviewStatus(vo);

        // 根据children的text值来将list中的数据进行分组
        if (children != null && children.size() > 0 && vo.getLevel() != 4) {
            for (int i = 0; i < children.size(); i++) {
                JSONObject jsonObject = children.getJSONObject(i);
                String text = jsonObject.getString("text");
                List<String> qyjdmcList = cameraAreaService.getQyjdmcList(jsonObject);
                List<CameraStatisticsVO> cameraStatisticsVOS = new ArrayList<>();
                if (qyjdmcList != null && qyjdmcList.size() > 0) {
                    for (String qyjdmc : qyjdmcList) {
                        for (CameraStatisticsVO cameraStatisticsVO : cameraStatisticsVOList) {
                            if (cameraStatisticsVO.getQyjdmc().equals(qyjdmc)) {
                                cameraStatisticsVOS.add(cameraStatisticsVO);
                            }
                        }
                    }
                }
                map.put(text, cameraStatisticsVOS);
            }
        }

        // 根据map中的数据进行计算
        List<CameraStatisticsVO> list = new ArrayList<>();
        if (map != null && map.size() > 0 && vo.getLevel() != 4) {
            for (Map.Entry<String, List<CameraStatisticsVO>> entry : map.entrySet()) {
                CameraStatisticsVO cameraStatisticsVO = new CameraStatisticsVO();
                String key = entry.getKey();
                List<CameraStatisticsVO> value = entry.getValue();
                Integer jksl = value.size();
                // 保留两位小数
                BigDecimal mtzxsc = new BigDecimal(0);
                BigDecimal mtlxwzsc = new BigDecimal(0);
                BigDecimal lxsc = new BigDecimal(0);
                BigDecimal wlxsc = new BigDecimal(0);

                if (value != null && value.size() > 0) {
                    for (CameraStatisticsVO statisticsVO : value) {
                        mtzxsc = mtzxsc.add(new BigDecimal(statisticsVO.getMtzxsc()));
                        mtlxwzsc = mtlxwzsc.add(new BigDecimal(statisticsVO.getMtlxwzsc()));
                        lxsc = lxsc.add(new BigDecimal(statisticsVO.getLxsc()));
                        wlxsc = wlxsc.add(new BigDecimal(statisticsVO.getWlxsc()));
                    }
                }
                cameraStatisticsVO.setQyjdmc(key);
                cameraStatisticsVO.setQymc(key);
                cameraStatisticsVO.setJksl(jksl);
//                cameraStatisticsVO.setOrgname(vo.getOrgname());
                cameraStatisticsVO.setMtzxsc(mtzxsc.toString());
                cameraStatisticsVO.setMtlxwzsc(mtlxwzsc.toString());
                cameraStatisticsVO.setLxsc(lxsc.toString());
                cameraStatisticsVO.setWlxsc(wlxsc.toString());
                list.add(cameraStatisticsVO);
            }
        }
        if (vo.getLevel() == 4) {
            list = cameraStatisticsVOList;
        }
        Date xxcjsjks = vo.getXxcjsjks();
        Date xxcjsjjs = vo.getXxcjsjjs();
        // 将日期转成yyyy-MM-dd格式,并返回日期格式
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        int day = 0;
        try {
            if (xxcjsjks != null) {
                xxcjsjks = sdf.parse(sdf.format(xxcjsjks));
                xxcjsjjs = sdf.parse(sdf.format(xxcjsjjs));
                // 获取两个日期之间的天数
                day = (int) ((xxcjsjjs.getTime() - xxcjsjks.getTime()) / (1000 * 3600 * 24)) + 1;
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

        if (list.size() > 0) {
            for (CameraStatisticsVO cameraStatisticsVO : list) {
                // 监控点在线率 = 在线时长 /（在线时长+离线时长）* 100%
                // 录像完整率 = 完整时长 /（完整时长+丢失时长）* 100%
                // 判断分母是否为0
                if (new BigDecimal(cameraStatisticsVO.getMtzxsc()).add(new BigDecimal(cameraStatisticsVO.getLxsc())).compareTo(new BigDecimal(0)) == 0) {
                    cameraStatisticsVO.setJkdzxl("0.00%");
                } else {
                    String jkdzxl = new BigDecimal(cameraStatisticsVO.getMtzxsc())
                            .divide(new BigDecimal(cameraStatisticsVO.getMtzxsc())
                                    .add(new BigDecimal(cameraStatisticsVO.getLxsc())), 4, RoundingMode.HALF_UP)
                            .multiply(new BigDecimal(100)).setScale(2, RoundingMode.HALF_UP) + "%";
                    cameraStatisticsVO.setJkdzxl(jkdzxl);
                }
                if (new BigDecimal(cameraStatisticsVO.getMtlxwzsc()).add(new BigDecimal(cameraStatisticsVO.getWlxsc())).compareTo(new BigDecimal(0)) == 0) {
                    cameraStatisticsVO.setLxwzl("0.00%");
                } else {
                    String lxwzl = new BigDecimal(cameraStatisticsVO.getMtlxwzsc())
                            .divide(new BigDecimal(cameraStatisticsVO.getMtlxwzsc())
                                    .add(new BigDecimal(cameraStatisticsVO.getWlxsc())), 4, RoundingMode.HALF_UP)
                            .multiply(new BigDecimal(100)).setScale(2, RoundingMode.HALF_UP) + "%";
                    cameraStatisticsVO.setLxwzl(lxwzl);
                }
                // 离线时长，小时换算成天，保留两位小数
                String lxsc = new BigDecimal(cameraStatisticsVO.getLxsc())
                        .divide(new BigDecimal(24), 2, RoundingMode.HALF_UP).toString();
                cameraStatisticsVO.setLxsc(lxsc);
                // 未录像时长，小时换算成天，保留两位小数
                String wlxsc = new BigDecimal(cameraStatisticsVO.getWlxsc())
                        .divide(new BigDecimal(24), 2, RoundingMode.HALF_UP).toString();
                cameraStatisticsVO.setWlxsc(wlxsc);
                // 监控点数量=监控点总数/天数,保留整数
//                if (vo.getLevel() != 4) {
//                    Integer jksl = new BigDecimal(cameraStatisticsVO.getJksl())
//                            .divide(new BigDecimal(day), 0, RoundingMode.HALF_UP).intValue();
//                    cameraStatisticsVO.setJksl(jksl);
//                }

            }
        }
        return list;
    }

    // 每天零点零五分执行一次
//    @Scheduled(cron = "0 5 0 * * ?")
    public void insertCameraPreviewStatus(String cookie, String from, String to) {
        try {
            String url = "https://10.69.3.1/nms/ui/v1/cameraOfflineTime/list";
            Map<String, String> map = new HashMap<String, String>();
            map.put("resOrgId", "root000000");
            map.put("pageNo", "1");
            map.put("pageSize", "20");
            map.put("includeSubNode", "1");
//            // 获取昨天时间
//            Calendar calendar = Calendar.getInstance();
//            calendar.add(Calendar.DATE, -1);
//            Date date = calendar.getTime();
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
            map.put("from", from);
            map.put("to", to);
            // 先删除昨天的数据
            kshHlhtSbxxMapper.deleteCameraPreviewStatusByXxcjsj(from, to);
            String result = addUri(cookie, url, map);
            if (result != null) {
                JSONObject jsonString = JSONObject.parseObject(result);
                if (jsonString != null && jsonString.getString("data") != null) {
                    JSONObject data = (JSONObject) jsonString.get("data");
                    String total = data.getString("total");

                    // 根据total创建线程循环获取数据
                    int totalSize = Integer.parseInt(total);
                    if (totalSize > 0) {
                        JSONArray list = new JSONArray();
                        list = getCameraForThread(cookie, url, map, totalSize);
                        System.out.println(list);
                        if (list.size() > 0) {
                            // 批量新增数据
                            List<CameraStatistics> cameraStatistics = new ArrayList<>();
                            // 将JSONArray转换成List
                            for (int i = 0; i < list.size(); i++) {
                                CameraStatistics cameraStatistics1 = new CameraStatistics();
                                JSONObject jsonObject = list.getJSONObject(i);
                                cameraStatistics1.setId(UUID.randomUUID().toString().replace("-", ""));
                                // 信息采集时间
                                cameraStatistics1.setXxcjsj(sdf.parse(to));
                                cameraStatistics1.setLxsc(jsonObject.getString("offlinetime").replace("小时", ""));
                                // 获取所有小时，to和from转换成yyyy-MM-dd HH:mm:ss格式,其中from为零点，to为23点59分59秒
                                SimpleDateFormat sdf1 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                                String from1 = from + " 00:00:00";
                                String to1 = to + " 23:59:59";
                                Date from2 = sdf1.parse(from1);
                                Date to2 = sdf1.parse(to1);
                                // 获取两个日期之间的小时数
                                int hours = (int) ((to2.getTime() - from2.getTime()) / (1000 * 3600)) + 1;
                                // mtzxsc = hours - offlinetime,保留两位小数
                                BigDecimal mtzxsc = new BigDecimal(hours).subtract(new BigDecimal(jsonObject.getString("offlinetime").replace("小时", "")));
                                cameraStatistics1.setMtzxsc(mtzxsc.setScale(2, RoundingMode.HALF_UP).toString());
                                cameraStatistics1.setWlxsc(jsonObject.getString("unrecordduration").replace("小时", ""));
                                // mtlxwzsc = hours - unrecordduration,保留两位小数
                                BigDecimal mtlxwzsc = new BigDecimal(hours).subtract(new BigDecimal(jsonObject.getString("unrecordduration").replace("小时", "")));
                                cameraStatistics1.setMtlxwzsc(mtlxwzsc.setScale(2, RoundingMode.HALF_UP).toString());
                                cameraStatistics1.setStatuschangecount(jsonObject.getString("statuschangecount"));
                                // 区域名称为fullorgpath截取第一个/和第二个/去除空格后的字符串
                                String fullorgpath = jsonObject.getString("fullorgpath");
                                String[] split = fullorgpath.split("/");
                                if (fullorgpath.contains("/")) {
                                    String qymc = split[1].trim();
                                    cameraStatistics1.setQymc(qymc);
                                    // 如果fullorgpath包含三个/，代表市储，如果包含两个，代表外地或者公司
                                    if (split.length > 2) {
                                        String qyjdmc = split[2].trim();
                                        cameraStatistics1.setQyjdmc(qyjdmc);
                                    } else {
                                        String qyjdmc = split[1].trim();
                                        cameraStatistics1.setQyjdmc(qyjdmc);
                                    }
                                }
                                cameraStatistics1.setOrgname(jsonObject.getString("orgname"));
                                cameraStatistics1.setIndexcode(jsonObject.getString("indexcode"));
                                cameraStatistics1.setResourcename(jsonObject.getString("resourcename"));
                                cameraStatistics1.setOnline(jsonObject.getString("online"));
                                cameraStatistics.add(cameraStatistics1);
                            }
                            // 批量新增数据
                            if (cameraStatistics.size() > 0) {
                                for (CameraStatistics cameraStatistic : cameraStatistics) {
                                    kshHlhtSbxxMapper.insertCameraPreviewStatus(cameraStatistic);
                                }
                            }
                        }
                    }
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private JSONArray getCameraForThread(String cookie, String url, Map<String, String> map, int totalSize) {
        JSONArray list = new JSONArray();
        try {
            // 在这里执行获取数据的逻辑
            // 假设你有一个方法fetchData来获取数据
            map.put("pageNo", "1");
            map.put("pageSize", String.valueOf(totalSize));
            String s = addUri(cookie, url, map);
            if (s != null) {
                JSONObject jsonString = JSONObject.parseObject(s);
                if (jsonString != null && jsonString.getString("data") != null) {
                    JSONObject data = (JSONObject) jsonString.get("data");
                    JSONArray partialList = (JSONArray) data.get("list");
                    list.addAll(partialList);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return list;
    }

    public static void main(String[] args) throws Exception {
        String pwd = "A1b2c3d4e5";
        String vcode = "c265f3c3-5e9d-4c9f-bda7-faecfeb2b0a2";
        String salt = "b73fbb7dc4cccf42d11615d0993f3413bc9b85c20aae03a20e15aae70fb7fb63";
        // encryptPswd = SHA256(SHA256（pwd+salt）+vcode)
        String p1 = pwd + salt;
        MessageDigest digest = MessageDigest.getInstance("SHA-256");
        byte[] hash = digest.digest(p1.getBytes("UTF-8"));
        String p2 = bytesToHex(hash);
        String p3 = p2 + vcode;
        byte[] hash2 = digest.digest(p3.getBytes("UTF-8"));
        String p4 = bytesToHex(hash2);
        System.out.println(p4);
    }

    // 获取登录Cookie
    public static String getCookie() {
        // Cookie由三部分组成，JSESSIONID=LPlXSY_oSnk_a5iuox6q4ECfcWyy642DMdWJZHC8; PPA_CI=4ba8a5fcbf06b1343d0f15c2535f1269; CASTGC=TGT-760-u9yMmrjwEFehdDY0Zmf6olcIdsC1CNJrfQSF5KVpY9YqNb4G2C-cas
        // JSESSIONID，PPA_CI，CASTGC，其中PPA_CI是固定的，JSESSIONID和CASTGC是每次登录都会变化的
        StringBuilder cookie = new StringBuilder();
        try {
            // 先调用https://10.69.3.1/portal/login/ajax/postLoginData.do，返回的请求头中获取Cookie并赋值给JSESSIONID
            String loginUrl = "https://10.69.3.1/portal/login/ajax/postLoginData.do";
            Map<String, String> loginParam = new HashMap<String, String>();
            loginParam.put("userName", "admin");
            loginParam.put("password", "A1b2c3d4e5");

            // 发送post请求
            JSONObject s = addUri(loginUrl, loginParam);
            if (s != null) {
                JSONObject jsonString = JSONObject.parseObject(s.getString("responseBody"));
                if (jsonString != null && jsonString.getString("data") != null) {
                    JSONObject data = (JSONObject) jsonString.get("data");
                    String pwd = loginParam.get("password");
                    String vcode = data.getString("vCode");
                    String salt = data.getString("salt");
                    String codeId = data.getString("codeId");
                    // encryptPswd = SHA256(SHA256（pwd+salt）+vcode)
                    String p1 = pwd + salt;
                    MessageDigest digest = MessageDigest.getInstance("SHA-256");
                    byte[] hash = digest.digest(p1.getBytes("UTF-8"));
                    String p2 = bytesToHex(hash);
                    String p3 = p2 + vcode;
                    byte[] hash2 = digest.digest(p3.getBytes("UTF-8"));
                    String p4 = bytesToHex(hash2);
                    String submitUrl = "https://10.69.3.1/portal/login/ajax/submit.do";
                    Map<String, String> submitParam = new HashMap<String, String>();
                    submitParam.put("codeId", codeId);
                    submitParam.put("password", p4);
                    submitParam.put("serviceUrl", "https://10.69.3.1/portal/cas/loginPage?service=https://10.69.3.1:443/portal");
                    submitParam.put("userName", "admin");
                    submitParam.put("userType", "0");
                    submitParam.put("lang", "zh_CN");
                    // 发送post请求
                    JSONObject s2 = addUri(submitUrl, submitParam);
                    if (s2 != null) {
                        JSONObject subJson = JSONObject.parseObject(s2.getString("responseBody"));
                        if (subJson != null && subJson.getString("data") != null) {
                            String subUrlResult = subJson.getString("data");
                            // subData 为”https://10.69.3.1:443/bic/ssoService/v1/tokenLogin
                            // ?token=ST-167237-JGOI3kCollSeZVMZbdvl-cas
                            // &service=https://10.69.3.1:443/portal/login
                            // ?redirect=aHR0cHM6Ly8xMC42OS4zLjE6NDQzL3BvcnRhbA==“格式
                            // 发送get请求
                            JSONObject tokenLoginResult = addUriForGet(subUrlResult);
                            if (tokenLoginResult != null) {
                                String JSESSIONID = tokenLoginResult.getString("JSESSIONID");
                                String CASTGC = tokenLoginResult.getString("CASTGC");
                                cookie.append("JSESSIONID=").append(JSESSIONID).append("; PPA_CI=4ba8a5fcbf06b1343d0f15c2535f1269; CASTGC=").append(CASTGC);
                                return cookie.toString();
                            }
                        }
                    }
                }
            }

        } catch (Exception e) {
            e.printStackTrace();
        }
        return "";
    }

    private static JSONObject addUriForGet(String tokenLoginUrl) {
        try {
            // 忽略证书验证
            SSLContext sslContext = new SSLContextBuilder().loadTrustMaterial(null, (chain, authType) -> true).build();
            CookieStore cookieStore = new BasicCookieStore();
            HttpClient httpClient = HttpClients.custom()
                    .setSslcontext(sslContext)
                    .setDefaultCookieStore(cookieStore)
                    .setSSLHostnameVerifier(NoopHostnameVerifier.INSTANCE)
                    .build();

            HttpGet httpGet = new HttpGet(tokenLoginUrl);
            HttpResponse response = httpClient.execute(httpGet);

            String responseBody = EntityUtils.toString(response.getEntity());
            if (response.getStatusLine().getStatusCode() == 200) {
                JSONObject jsonObject = new JSONObject();
                // 在这里，你可以检查CookieStore以获取`CASTGC` Cookie
                for (Cookie cookieStoreCookie : cookieStore.getCookies()) {
                    jsonObject.put(cookieStoreCookie.getName(), cookieStoreCookie.getValue());
                }
                return jsonObject;
            } else {
                System.out.println("Response Code: " + response.getStatusLine().getStatusCode());
                return null;
            }

        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

    private static String bytesToHex(byte[] hash) {
        StringBuilder hexString = new StringBuilder();
        for (byte b : hash) {
            String hex = Integer.toHexString(0xff & b);
            if (hex.length() == 1) hexString.append('0');
            hexString.append(hex);
        }
        return hexString.toString();
    }

    public void exportCameraPreviewStatus(CameraStatisticsVO vo, HttpServletResponse response) {
        List<CameraStatisticsVO> list = getCameraStatisticsVOS(vo);
        // 导出
        try {
            if (!list.isEmpty()) {
                XSSFWorkbook workbook = new XSSFWorkbook();
                // 创建居中样式
                CellStyle centerStyle = workbook.createCellStyle();
                centerStyle.setAlignment(HSSFCellStyle.ALIGN_CENTER);
                centerStyle.setVerticalAlignment(HSSFCellStyle.VERTICAL_CENTER);
                // 创建sheet
                Sheet sheet = workbook.createSheet();
                // 根据level创建不同的表头
                if (vo.getLevel() == 1) {
                    // 设置sheet名称
                    workbook.setSheetName(0, "市级节点统计表");
                } else if (vo.getLevel() == 2) {
                    // 设置sheet名称
                    workbook.setSheetName(0, vo.getWjmc() + "区级节点统计表");
                } else if (vo.getLevel() == 3) {
                    // 设置sheet名称
                    if (list.get(0).getQymc().equals(list.get(0).getQyjdmc())) {
                        workbook.setSheetName(0, list.get(0).getQymc() + "库级节点统计表");
                    } else {
                        workbook.setSheetName(0, list.get(0).getQymc() + list.get(0).getQyjdmc() + "库级节点统计表");
                    }
                } else if (vo.getLevel() == 4) {
                    // 设置sheet名称
                    workbook.setSheetName(0, vo.getWjmc() + "摄像头分类节点统计表");
                }
                // 创建单元格
                String[] titles = {};
                if (vo.getLevel() == 1) {
                    titles = new String[]{"所在区域", "监控数量", "监控点在线率", "录像完整率"};
                } else if (vo.getLevel() == 2) {
                    titles = new String[]{"库点名称", "监控数量", "监控点在线率", "录像完整率"};
                } else if (vo.getLevel() == 3) {
                    titles = new String[]{"分类", "监控数量", "监控点在线率", "录像完整率"};
                } else if (vo.getLevel() == 4) {
                    titles = new String[]{"监控点名称", "类型", "离线时长（天）", "未录像时长（天）", "监控点在线率", "录像完整率", "状态变化次数"};
                }
                // 创建第一行，合并titles.length列
                Row firstRow = sheet.createRow(0);
                Cell firstCell = firstRow.createCell(0);
                firstCell.setCellValue(workbook.getSheetName(0));
                sheet.addMergedRegion(new CellRangeAddress(0, 0, 0, titles.length - 1));
                // 设置单元格字体宋体加粗
                Font firstRowFont = workbook.createFont();
                firstRowFont.setFontName("宋体");
                firstRowFont.setBoldweight(Font.BOLDWEIGHT_BOLD);
                firstRowFont.setFontHeightInPoints((short) 16);
                CellStyle firstRowStyle = workbook.createCellStyle();
                firstRowStyle.setFont(firstRowFont);
                firstRowStyle.setAlignment(HSSFCellStyle.ALIGN_CENTER);
                firstRowStyle.setVerticalAlignment(HSSFCellStyle.VERTICAL_CENTER);
                firstCell.setCellStyle(firstRowStyle); // 设置样式
                // 创建行
                Row row = sheet.createRow(1);
                // 设置表头样式灰色背景，宋体加粗，垂直居中，水平居中
                CellStyle style = workbook.createCellStyle();
                style.setFillForegroundColor(IndexedColors.GREY_25_PERCENT.getIndex());
                style.setFillPattern(CellStyle.SOLID_FOREGROUND);
                Font font = workbook.createFont();
                font.setFontName("宋体");
                // 加粗
                font.setBoldweight(Font.BOLDWEIGHT_BOLD);
                style.setFont(font);
                style.setAlignment(HSSFCellStyle.ALIGN_CENTER);
                style.setVerticalAlignment(HSSFCellStyle.VERTICAL_CENTER);

                for (int i = 0; i < titles.length; i++) {
                    Cell cell = row.createCell(i);
                    cell.setCellValue(titles[i]);
                    cell.setCellStyle(style);
                }
                int rowNum = 2;
                for (CameraStatisticsVO cameraStatisticsVO : list) {
                    Row row1 = sheet.createRow(rowNum);
                    if (vo.getLevel() == 1) {
                        row1.createCell(0).setCellValue(cameraStatisticsVO.getQymc());
                    } else if (vo.getLevel() == 2) {
                        row1.createCell(0).setCellValue(cameraStatisticsVO.getQyjdmc());
                    } else if (vo.getLevel() == 3) {
                        row1.createCell(0).setCellValue(cameraStatisticsVO.getOrgname());
                    } else if (vo.getLevel() == 4) {
                        row1.createCell(0).setCellValue(cameraStatisticsVO.getResourcename());
                    }
                    if (vo.getLevel() != 4) {
                        row1.createCell(1).setCellValue(cameraStatisticsVO.getJksl());
                        row1.createCell(2).setCellValue(cameraStatisticsVO.getJkdzxl());
                        row1.createCell(3).setCellValue(cameraStatisticsVO.getLxwzl());
                    } else {
                        row1.createCell(1).setCellValue(cameraStatisticsVO.getOrgname());
                        row1.createCell(2).setCellValue(cameraStatisticsVO.getLxsc());
                        row1.createCell(3).setCellValue(cameraStatisticsVO.getWlxsc());
                        row1.createCell(4).setCellValue(cameraStatisticsVO.getJkdzxl());
                        row1.createCell(5).setCellValue(cameraStatisticsVO.getLxwzl());
                        row1.createCell(6).setCellValue(cameraStatisticsVO.getStatuschangecount());
                    }

                    // 应用水平居中样式
                    for (int i = 0; i < titles.length; i++) {
                        row1.getCell(i).setCellStyle(centerStyle);
                    }
                    rowNum++;
                }
                // 自适应列宽
                for (int i = 0; i < titles.length; i++) {
                    sheet.autoSizeColumn(i);
                    // 字体大小
                    sheet.setColumnWidth(i, sheet.getColumnWidth(i) * 30 / 10);
                }
                // 设置响应类型和编码
                response.setContentType("application/vnd.ms-excel");
                response.setCharacterEncoding("utf-8");
                String fileName = URLEncoder.encode(sheet.getSheetName(), "UTF-8");
                response.setHeader("Content-disposition", "attachment;filename=" + fileName + ".xlsx");

                // 将工作簿写入输出流
                workbook.write(response.getOutputStream());
                response.getOutputStream().flush();
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            // 关闭工作簿
            try {
                response.getOutputStream().close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

	/*public List<KshHlhtSheng> queryParentId() {
		return kshHlhtXzqhMapper.queryParentId();
	}

	public List<KshHlhtSheng> queryChildListById(Integer id) {
		return kshHlhtXzqhMapper.queryChildListById(id);
	}*/

}
