package com.jusfoun.ydylsz.util;

import java.io.IOException;
import java.io.OutputStream;
import java.net.URLEncoder;
import java.util.List;
import javax.servlet.http.HttpServletResponse;
import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;

/**
 * 
 * @author ldq
 * description:描述excel模板生成
 */
public class ExcelModelUtils {
	/**
	 * 
	 * author:ldq
	 * date:2018年9月2日
	 * @param response 响应
	 * @param header   表头集合
	 * @param preStr 
	 * @throws IOException
	 * description:下载模板
	 */
	public static void downloadModel(HttpServletResponse response,List<String> header, String preStr) throws IOException {
		OutputStream out = null;
		try {
			out = response.getOutputStream();
			ExcelModelUtils.generateExcel("default", header, out);
			if(preStr != null) {
				preStr+="导入模板.xls";
			}else {
				preStr ="导入模板.xls";
			}
			// 设置响应头，控制浏览器下载该文件
			response.setHeader("content-disposition", "attachment;filename=" + URLEncoder.encode(preStr, "UTF-8"));
			// 关闭文件输入流
			out.flush();
			out.close();
		} catch (Exception e) {
			out.close();
			e.printStackTrace();
			return;
		}
	}
	
	/**
	 * @param sheetName 表名
	 * @param header 表头数据
	 */
	public static void generateExcel(String sheetName, List<String> header, OutputStream out) {
	    //新建excel报表
	    HSSFWorkbook excel = new HSSFWorkbook();
	    //添加一个sheet
	    HSSFSheet hssfSheet = excel.createSheet(sheetName);
	    //往excel表格创建一行，excel的行号是从0开始的
	    // 设置表头
	    HSSFRow firstRow = hssfSheet.createRow(0);
	    for (int columnNum = 0; columnNum < header.size(); columnNum ++) {
	        //创建单元格
	        HSSFCell hssfCell = firstRow.createCell(columnNum);
	        //设置单元格的值
	        hssfCell.setCellValue(header.size() < columnNum ? "-" : header.get(columnNum));
	    }
	    try {
	        excel.write(out);
	    } catch (IOException e) {
	        e.printStackTrace();
	    }
	}
	
}
