package com.jusfoun.ydylsz.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Column;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Date;
import java.util.List;

/**
 * @Classname CameraMalfunctionVO
 * @Description 摄像头故障报警表
 * @Date 2023/7/25 14:18
 * @Created by rising123sun
 */
@Data
@ApiModel(value = "摄像头故障报警表")
public class CameraMalfunctionDO {

    @ApiModelProperty(value = "库区名称")
    private String kqmc;

    // 离线总数量
    @ApiModelProperty(value = "离线总数量")
    private Integer offLineTotal;

    // 已备案数量
    @ApiModelProperty(value = "已备案数量")
    private Integer ybaTotal;

    // 未备案数量
    @ApiModelProperty(value = "未备案数量")
    private Integer wbaTotal;

    // 备案超时数量
    @ApiModelProperty(value = "备案超时数量")
    private Integer baCsTotal;

    @ApiModelProperty(value = "报警时间")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date bjrq;

    List<CameraMalfunctionDTO> cameraMalfunctionDTOS;

}
