package com.jusfoun.ydylsz.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Column;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Date;

/**
 * @Classname CameraMalfunctionVO
 * @Description 摄像头故障报警表
 * @Date 2023/7/25 14:18
 * @Created by rising123sun
 */
@Data
@ApiModel(value = "摄像头故障报警表")
public class CameraMalfunctionDTO {

    @ApiModelProperty(value = "库区编码")
    private String kqbm;

    @ApiModelProperty(value = "库区代码")
    private String kqdm;

    @ApiModelProperty(value = "库区名称")
    private String kqmc;

    @ApiModelProperty(value = "监控点编码")
    private String jkdbm;

    @ApiModelProperty(value = "监控点名称")
    private String jkdmc;

    @ApiModelProperty(value = "故障类型")
    private String gzlx;

    @ApiModelProperty(value = "报警时间")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date bjsj;

    @ApiModelProperty(value = "数据创建时间")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date create_time;

    @ApiModelProperty(value = "数据修改时间")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date update_time;

    // 离线预警状态
    @ApiModelProperty(value = "离线预警状态")
    private String lxyjzt;

    // 离线通知单id
    @Column(name = "lxtzdid")
    @ApiModelProperty(value = "离线通知单id")
    private Long lxtzdid;

    // 运维信息工单id
    @Column(name = "ywxxgdid")
    @ApiModelProperty(value = "运维信息工单id")
    private Long ywxxgdid;

    @ApiModelProperty(value = "申请离线时间段")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date offLineDateBegin;

    @ApiModelProperty(value = "申请离线时间段")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date offLineDateEnd;

    @ApiModelProperty(value = "粮库审核人盖章时间")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date verifySealDate;


    // 离线通知单工单编号
    @ApiModelProperty(value = "离线通知单工单编号")
    private String lxtzdgdbh;

    // 运维信息工单工单编号
    @ApiModelProperty(value = "运维信息工单工单编号")
    private String ywxxgdgdbh;

    // 离线通知单审核状态
    @ApiModelProperty(value = "离线通知单审核状态")
    private String lxtzdshzt;

    // 运维信息工单审核状态
    @ApiModelProperty(value = "运维信息工单审核状态")
    private String ywxxgdshzt;

    // 离线通知单
    private OpsOffLineVO opsOffLineVO;

    // 运维工单
    private WorkOrderVO workOrderVO;


}
