package com.jusfoun.ydylsz.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.gbase.jdbc.log.Log;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Column;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Date;

/**
 * @Classname CameraMalfunctionVO
 * @Description 摄像头故障报警表
 * @Date 2023/7/25 14:18
 * @Created by rising123sun
 */
@Data
@Table(name = "camera_malfunction")
@ApiModel(value = "摄像头故障报警表")
public class CameraMalfunctionVO {

    @Id
    private String id;

    @Column(name = "kqbm")
    @ApiModelProperty(value = "库区编码")
    private String kqbm;

    @Column(name = "kqdm")
    @ApiModelProperty(value = "库区代码")
    private String kqdm;

    @Column(name = "kqmc")
    @ApiModelProperty(value = "库区名称")
    private String kqmc;

    @Column(name = "jkdbm")
    @ApiModelProperty(value = "监控点编码")
    private String jkdbm;

    @Column(name = "jkdmc")
    @ApiModelProperty(value = "监控点名称")
    private String jkdmc;

    @Column(name = "gzlx")
    @ApiModelProperty(value = "故障类型")
    private String gzlx;

    @Column(name = "bjsj")
    @ApiModelProperty(value = "报警时间")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date bjsj;

    @Column(name = "create_time")
    @ApiModelProperty(value = "数据创建时间")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date create_time;

    @Column(name = "update_time")
    @ApiModelProperty(value = "数据修改时间")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date update_time;

    // 离线通知单id
    @Column(name = "lxtzdid")
    @ApiModelProperty(value = "离线通知单id")
    private Long lxtzdid;

    // 运维信息工单id
    @Column(name = "ywxxgdid")
    @ApiModelProperty(value = "运维信息工单id")
    private Long ywxxgdid;


}
