package com.jusfoun.ydylsz.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiOperation;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Column;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Date;

/**
 * @Classname CameraStatistics
 * @Description 视频监控统计
 * @Date 2023/8/29 14:10
 * @Created by rising123sun
 */
@Data
@Table(name = "camera_statistics")
@ApiModel(value = "视频监控统计")
public class CameraStatistics {
    @Id
    @ApiModelProperty(value = "主键", notes = "主键")
    private String id;

    @Column(name = "lxsc")
    @ApiModelProperty(value = "离线时长", notes = "离线时长")
    private String lxsc;

    @Column(name = "mtzxsc")
    @ApiModelProperty(value = "每天在线时长", notes = "每天在线时长")
    private String mtzxsc;

    @Column(name = "wlxsc")
    @ApiModelProperty(value = "未录像时长", notes = "未录像时长")
    private String wlxsc;

    @Column(name = "mtlxwzsc")
    @ApiModelProperty(value = "每天录像完整时长", notes = "每天录像完整时长")
    private String mtlxwzsc;

    @Column(name = "statuschangecount")
    @ApiModelProperty(value = "状态变化次数", notes = "状态变化次数")
    private String statuschangecount;

    @Column(name = "qymc")
    @ApiModelProperty(value = "区域名称", notes = "区域名称")
    private String qymc;

    @Column(name = "qyjdmc")
    @ApiModelProperty(value = "区域节点名称", notes = "区域节点名称")
    private String qyjdmc;

    @Column(name = "xxcjsj")
    @ApiModelProperty(value = "信息采集时间")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date xxcjsj;

    @Column(name = "orgname")
    @ApiModelProperty(value = "类型：仓内，业务，安防")
    private String orgname;

    @Column(name = "indexcode")
    @ApiModelProperty(value = "设备唯一标识")
    private String indexcode;

    @Column(name = "resourcename")
    @ApiModelProperty(value = "监控点名称")
    private String resourcename;

    @Column(name = "online")
    @ApiModelProperty(value = "在线状态:0离线，1在线")
    private String online;
}
