package com.jusfoun.ydylsz.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Column;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Date;

/**
 * @author by PIG
 * 2023/8/2 09
 */
@ApiModel(value = "离线通知单")
@Data
@Table(name = "ops_off_line")
public class OpsOffLineDO {

    @Id
    @Column(name = "fid")
    private Long fid;

    @Column(name = "gdbh")
    @ApiModelProperty(value = "LX-202301001", example = "LX-202301001")
    private String gdbh;

    @Column(name = "sqdwmc")
    private String sqdwmc;

    @Column(name = "sqdwdm")
    private String sqdwdm;

    @ApiModelProperty(value = "申请人")
    @Column(name = "sqr")
    private String sqr;

    @ApiModelProperty(value = "申请日期")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @Column(name = "sqrq")
    private Date sqrq;

    /** 申请人联系方式*/
    @ApiModelProperty(value = "申请人联系方式")
    @Column(name = "sqrlxfs")
    private String sqrlxfs;

    @Column(name = "off_line_date_begin")
    private Date offLineDateBegin;

    @Column(name = "off_line_date_end")
    private Date offLineDateEnd;

    @Column(name = "off_line_desc")
    private String offLineDesc;
    @Column(name = "job_status")
    private Integer jobStatus;

    @Column(name = "job_content_and_local")
    private String jobContentAndLocal;
    @Column(name = "order_attachment")
    private String orderAttachment;
    @Column(name = "parent_account")
    private String parentAccount;

    @Column(name = "verify_desc")
    private String verifyDesc;

    @Column(name = "verify_person")
    private String verifyPerson;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @Column(name = "verify_date")
    private Date verifyDate;

    @Column(name = "verify_seal")
    private String verifySeal;

    @ApiModelProperty(value = "粮库审核人盖章时间")
    @Column(name = "verify_seal_date")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date verifySealDate;

    @Column(name = "dgo_verify_res")
    private String dgoVerifyRes;
    @Column(name = "dgo_verifier")
    private String dgoVerifier;
    @Column(name = "dgo_verify_desc")
    private String dgoVerifyDesc;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @Column(name = "dgo_verify_date")
    private Date dgoVerifyDate;

    @Column(name = "urban_verify_res")
    private String urbanVerifyRes;
    @Column(name = "urban_verifier")
    private String urbanVerifier;
    @Column(name = "urban_verify_desc")
    private String urbanVerifyDesc;
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @Column(name = "urban_verify_date")
    private Date urbanVerifyDate;


    @Column(name = "ic_verify_res")
    private String icVerifyRes;

    @Column(name = "ic_verifier")
    private String icVerifier;

    @Column(name = "ic_verify_desc")
    private String icVerifyDesc;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @Column(name = "ic_verify_date")
    private Date icVerifyDate;

    /**
     * 待审核 91000010 审核驳回 91000001 待盖章 91000020 盖章驳回 91000011
     *
     * 已完成 91000070
     */
    @Column(name = "shzt")
    private String shzt;
    @Column(name = "shztmc")
    private String shztmc;

    @Column(name = "work_order_type")
    private Integer workOrderType;

    @Column(name = "work_order_type_name")
    private String workOrderTypeName;

    @ApiModelProperty(name = "摄像头是否有故障")
    @Column(name = "camera_mal")
    private Integer cameraMal;

    @Column(name = "auto_create_work_order")
    private Integer autoCreateWorkOrder;

}
