package com.jusfoun.ydylsz.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Column;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Date;
import java.util.List;

/**
 * @author by PIG
 * 2023/8/2 10
 */
@ApiModel(value = "离线通知单")
@Data
@EqualsAndHashCode(callSuper = true)
@Table(name = "ops_off_line")
public class OpsOffLineVO extends BaseVO {

    @Id
    @Column(name = "fid")
    private Long fid;

    @Column(name = "gdbh")
    @ApiModelProperty(name = "", value = "LX-202301001", example = "LX-202301001")
    private String gdbh;

    @ApiModelProperty(name = "申请单位名称")
    @Column(name = "sqdwmc")
    private String sqdwmc;

    @Column(name = "sqdwdm")
    private String sqdwdm;

    @ApiModelProperty(name = "申请人")
    @Column(name = "sqr")
    private String sqr;

    @ApiModelProperty(value = "申请日期")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @Column(name = "sqrq")
    private Date sqrq;

    @ApiModelProperty(value = "申请人联系方式")
    @Column(name = "sqrlxfs")
    private String sqrlxfs;

    @ApiModelProperty(value = "申请离线时间段")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @Column(name = "off_line_date_begin")
    private Date offLineDateBegin;

    @ApiModelProperty(value = "申请离线时间段")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @Column(name = "off_line_date_end")
    private Date offLineDateEnd;

    @ApiModelProperty(value = "设备离线（故障）情况描述")
    @Column(name = "off_line_desc")
    private String offLineDesc;

    @ApiModelProperty(value = "申请离线摄像头范围内是否有储粮作业")
    @Column(name = "job_status")
    private Integer jobStatus;

    @ApiModelProperty(value = "作业内容和位置")
    @Column(name = "job_content_and_local")
    private String jobContentAndLocal;
    @ApiModelProperty(value = "附件")
    @Column(name = "order_attachment")
    private String orderAttachment;

    @ApiModelProperty(value = "上级审批单位")
    @Column(name = "parent_account")
    private String parentAccount;

    @ApiModelProperty(value = "主管领导意见")
    @Column(name = "verify_desc")
    private String verifyDesc;

    @ApiModelProperty(value = "审核人")
    @Column(name = "verify_person")
    private String verifyPerson;

    @ApiModelProperty(value = "")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @Column(name = "verify_date")
    private Date verifyDate;

    @ApiModelProperty(value = "")
    @Column(name = "verify_seal")
    private String verifySeal;

    @ApiModelProperty(value = "签章状态 0:签章驳回 1:已签章")
    @Column(name = "signature_status")
    private String signatureStatus;

    @ApiModelProperty(value = "粮库审核人盖章时间")
    @Column(name = "verify_seal_date")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date verifySealDate;

    @ApiModelProperty(value = "区粮办确认")
    @Column(name = "dgo_verify_res")
    private String dgoVerifyRes;
    @ApiModelProperty(value = "区粮办人员")
    @Column(name = "dgo_verifier")
    private String dgoVerifier;
    @Column(name = "dgo_verify_desc")
    private String dgoVerifyDesc;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @Column(name = "dgo_verify_date")
    private Date dgoVerifyDate;

    @Column(name = "urban_verify_res")
    private String urbanVerifyRes;
    @ApiModelProperty(value = "市局人员")
    @Column(name = "urban_verifier")
    private String urbanVerifier;
    @Column(name = "urban_verify_desc")
    private String urbanVerifyDesc;
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @Column(name = "urban_verify_date")
    private Date urbanVerifyDate;


    @Column(name = "ic_verify_res")
    private String icVerifyRes;

    @ApiModelProperty(name = "信息中心人员")
    @Column(name = "ic_verifier")
    private String icVerifier;
    @ApiModelProperty(name = "")
    @Column(name = "ic_verify_desc")
    private String icVerifyDesc;

    @ApiModelProperty(name = "")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @Column(name = "ic_verify_date")
    private Date icVerifyDate;

    /**
     * 待审核 91000010 审核驳回 91000001 待盖章 91000020 盖章驳回 91000011
     *
     * 已完成 91000070
     */
    @ApiModelProperty(name = "审核状态")
    @Column(name = "shzt")
    private String shzt;
    @ApiModelProperty(name = "审核状态名称")
    private String shztmc;

    /**
     * 工单类型 2离线<br/>
     */
    @ApiModelProperty(name = "工单类型")
    @Column(name = "work_order_type")
    private Integer workOrderType = 2;

    @ApiModelProperty(name = "工单类型名称")
    @Column(name = "work_order_type_name")
    private String workOrderTypeName = "离线";

    @ApiModelProperty(name = "摄像头是否有故障", allowableValues ="0,1")
    @Column(name = "camera_mal")
    private Integer cameraMal;

    @ApiModelProperty(name = "是否自动创建工单 0否 1是", allowableValues ="0,1")
    @Column(name = "auto_create_work_order")
    private Integer autoCreateWorkOrder;

    @ApiModelProperty(name = "摄像头")
    private List<OpsOffLineCameraVO> cameraList;

    public enum DESC_CONSTANT {
        /** 不同意*/
        N("0", "不同意"),
        /**同意*/
        Y("1", "同意");

        private final String value;
        private final String name;

        DESC_CONSTANT(String value, String name) {
            this.value = value;
            this.name = name;
        }
        public boolean equalsVal(String targetVal) {
            return this.value.equals(targetVal);
        }
    }

    public enum AUTO_CREATE_WorkOrder {
        N(0),
        Y(1);
        @Getter
        private int value;

        AUTO_CREATE_WorkOrder(Integer val) {
            this.value = val;
        }

        public boolean equal(Integer targetVal) {
            return null != targetVal && this.value == targetVal;
        }
    }

    public enum NODE_CONSTANT {
        PENDING_SAVE("91000000", "创建"),
        VERIFY_REJECT("91000001", "审核驳回"),
        /**
         * 待审核
         */
        PENDING_VERIFY("91000010", "待审核"),
        SEAL_REJECT("91000011", "盖章驳回"),

        PENDING_SEAL("91000020", "待盖章"),
        DGO_REJECT1("91000021", "区粮办驳回"),
        DGO_REJECT2("91000021", "中粮利金驳回"),
        DGO_REJECT3("91000021", "利达粮油驳回"),
        DGO_REJECT4("91000021", "市储备公司驳回"),
        /**
         * 待区粮办备案
         */
        PENDING_DGO1("91000030", "待区粮办备案"),
        PENDING_DGO2("91000030", "待中粮利金备案"),
        PENDING_DGO3("91000030", "待利达粮油备案"),
        PENDING_DGO4("91000030", "待市储备公司备案"),
        URBAN_REJECT("91000031", "市储备处驳回"),
        /**
         * 待市储备处备案
         */
        PENDING_URBAN("91000040", "待市储备处备案"),
        IC_REJECT("91000041", "信息中心驳回"),
        PENDING_IC("91000050", "待信息中心备案"),
        /**
         * 已完成
         */
        FINISHED("91000060", "已完成");

        @Getter
        private final String value;
        @Getter
        private final String name;

        NODE_CONSTANT(String value, String name) {
            this.value = value;
            this.name = name;
        }

        public boolean equalsVal(String targetVal) {
            return this.value.equals(targetVal);
        }
    }

    public boolean computedKey(List<String> list) {
        list.contains(this.shzt);

        return false;
    }
}
