package com.jusfoun.ydylsz.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.Setter;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Column;
import javax.persistence.Table;
import java.util.Date;
import java.util.List;

/**
 * @author by PIG
 * 2023/2/13 16
 */
@ApiModel(value = "运维工单")
@Data
@Table(name = "ops_work_order")
public class WorkOrderVO extends BaseVO {

    @Column(name = "fid")
    private Long fid;

    @ApiModelProperty(value = "工单编号")
    @Column(name = "gdbh")
    private String gdbh;

    /**申请单位名称*/
    @ApiModelProperty(value = "申请单位名称")
    @Setter
    @Column(name = "sqdwmc")
    private String sqdwmc;

    @ApiModelProperty(value = "申请单位代码")
    @Column(name = "sqdwdm")
    private String sqdwdm;

    @ApiModelProperty(value = "系统名称")
    @Column(name = "web_sys_name")
    private String webSysName;

    @ApiModelProperty(value = "申请人联系方式")
    @Column(name = "sqrlxfs")
    private String sqrlxfs;

    @ApiModelProperty(value = "问题情况描述")
    @Column(name = "problem_desc")
    private String problemDesc;

    @ApiModelProperty(value = "问题附件")
    @Column(name = "problem_file")
    private String problemFile;

    @ApiModelProperty(value = "申请人")
    @Column(name = "sqr")
    private String sqr;

    @ApiModelProperty(value = "")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @Column(name = "sqrq")
    private Date sqrq;

    @ApiModelProperty(value = "主管领导意见")
    @Column(name = "zgldyj")
    private String zgldyj;

    @ApiModelProperty(value = "审核人")
    @Column(name = "verify_person")
    private String verifyPerson;

    @ApiModelProperty(value = "")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @Column(name = "verify_date")
    private Date verifyDate;

    @ApiModelProperty(value = "审核人签章")
    @Column(name = "qhrqz")
    private String qhrqz;

    @ApiModelProperty(value = "粮库审核人盖章时间")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date verifySealDate;

    @ApiModelProperty(value = "受理人员")
    @Column(name = "accept_person")
    private String acceptPerson;

    @ApiModelProperty(value = "")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @Column(name = "accept_date")
    private Date acceptDate;

    @ApiModelProperty(value = "")
    @Column(name = "problem_type")
    private String problemType;

    @ApiModelProperty(value = "")
    @Column(name = "solve_type")
    private String solveType;

    @ApiModelProperty(value = "")
    @Column(name = "solve_res")
    private String solveRes;

    @ApiModelProperty(value = "")
    @Column(name = "solve_file")
    private String solveFile;

    @ApiModelProperty(value = "")
    @Column(name = "solve_remark")
    private String solveRemark;

    @ApiModelProperty(value = "")
    @Column(name = "solve_person")
    private String solvePerson;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @Column(name = "solve_date")
    private Date solveDate;

    @Column(name = "applicant_verify_res")
    private String applicantVerifyRes;

    @Column(name = "applicant_verify")
    private String applicantVerify;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @Column(name = "applicant_verify_date")
    private Date applicantVerifyDate;

    @Column(name = "ic_verify_res")
    private String icVerifyRes;

    @Column(name = "ic_verify")
    private String icVerify;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @Column(name = "ic_verify_date")
    private Date icVerifyDate;

    @Column(name = "shzt")
    private String shzt;
    private Integer workOrderType;
    private String workOrderTypeName;

    @ApiModelProperty(value = "处理数量")
    private int solveCount;
    @ApiModelProperty(value = "追加问题数量")
    private int problemCount;

    @ApiModelProperty(value = "设备离线单fid")
    private Long opsOffLineFid;

    @ApiModelProperty(name = "摄像头")
    private List<OpsOffLineCameraVO> cameraList;

    public enum NODE_CONSTANT{
        /**待受理*/
        PENDING_ACCEPT("91000030", "待受理"),
        /**已完成*/
        FINISHED("91000070", "已完成");

        private String value;
        private String name;

        NODE_CONSTANT(String value, String name) {
            this.value = value;
            this.name = name;
        }

        public boolean equalsVal(String targetVal) {
            return this.value.equals(targetVal);
        }
    }
    @ApiModelProperty(value = "提交时间开始")
    private String verifySealDateBegin;
    private String verifySealDateEnd;

    @ApiModelProperty(value = "受理时间开始")
    private String acceptDateBegin;
    private String acceptDateEnd;

    @ApiModelProperty(value = "解决时间开始")
    private String solveDateBegin;
    private String solveDateEnd;

}
