package com.jusfoun.ydylsz.vo.in;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Column;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Date;
import java.util.List;

/**
 * @Classname CameraStatistics
 * @Description 视频监控统计
 * @Date 2023/8/29 14:10
 * @Created by rising123sun
 */
@Data
@ApiModel(value = "视频监控统计")
public class CameraStatisticsVO {
    @ApiModelProperty(value = "主键", notes = "主键")
    private String id;

    @ApiModelProperty(value = "离线时长", notes = "离线时长")
    private String lxsc;

    @ApiModelProperty(value = "每天在线时长", notes = "每天在线时长")
    private String mtzxsc;

    @ApiModelProperty(value = "未录像时长", notes = "未录像时长")
    private String wlxsc;

    @ApiModelProperty(value = "每天录像完整时长", notes = "每天录像完整时长")
    private String mtlxwzsc;

    @ApiModelProperty(value = "状态变化次数", notes = "状态变化次数")
    private String statuschangecount;

    @Column(name = "qymc")
    @ApiModelProperty(value = "区域名称", notes = "区域名称")
    private String qymc;

    @Column(name = "qyjdmc")
    @ApiModelProperty(value = "区域节点名称", notes = "区域节点名称")
    private String qyjdmc;

    @ApiModelProperty(value = "信息采集时间")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date xxcjsj;

    @ApiModelProperty(value = "类型：仓内，业务，安防")
    private String orgname;

    @ApiModelProperty(value = "设备唯一标识")
    private String indexcode;

    @ApiModelProperty(value = "监控点名称")
    private String resourcename;

    @ApiModelProperty(value = "在线状态:0离线，1在线")
    private String online;

    @ApiModelProperty(value = "信息采集时间开始")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date xxcjsjks;

    @ApiModelProperty(value = "信息采集时间结束")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date xxcjsjjs;

    // 查询等级,1:市级,2:区域,3:库点,4:库点摄像头分类
    @ApiModelProperty(value = "查询等级,1:市级,2:区域,3:库点,4:库点摄像头分类")
    private Integer level;

    @ApiModelProperty(value = "查询级别,1:非库点，2，库点")
    private Integer levelType;

    // orgCode
    @ApiModelProperty(value = "orgCode")
    private String orgCode;

    List<String> qyjdmcList;

    // 监控数量
    @ApiModelProperty(value = "监控数量")
    private Integer jksl;

    // 文件名称
    @ApiModelProperty(value = "文件名称")
    private String wjmc;

    // 监控点在线率
    @ApiModelProperty(value = "监控点在线率")
    private String jkdzxl;

    // 录像完整率
    @ApiModelProperty(value = "录像完整率")
    private String lxwzl;

    private List<String> orgnameList;

}
